/*
 * Cloudera Manager API
 * <h1>Cloudera Manager API v51</h1>       <p>Introduced in Cloudera Manager 7.9.5</p>       <p><a href=\"http://www.cloudera.com/documentation.html\">Cloudera Product Documentation</a></p>
 *
 * OpenAPI spec version: 7.9.5
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.cloudera.api.swagger.model;

import java.util.Objects;
import com.cloudera.api.swagger.model.ApiEntityTag;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * A Control Plane in a Cloudera Manager instance
 */
@ApiModel(description = "A Control Plane in a Cloudera Manager instance")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2023-01-19T06:59:17.581Z")
public class ApiControlPlane {
  @SerializedName("namespace")
  private String namespace = null;

  @SerializedName("dnsSuffix")
  private String dnsSuffix = null;

  @SerializedName("uuid")
  private String uuid = null;

  @SerializedName("remoteRepoUrl")
  private String remoteRepoUrl = null;

  @SerializedName("version")
  private String version = null;

  @SerializedName("manifest")
  private String manifest = null;

  @SerializedName("valuesYaml")
  private String valuesYaml = null;

  @SerializedName("tags")
  private List<ApiEntityTag> tags = null;

  @SerializedName("kubernetesType")
  private String kubernetesType = null;

  public ApiControlPlane namespace(String namespace) {
    this.namespace = namespace;
    return this;
  }

   /**
   * The namespace where the control plane is installed. Append the domain to the namespace to get the url of the control plane.
   * @return namespace
  **/
  @ApiModelProperty(value = "The namespace where the control plane is installed. Append the domain to the namespace to get the url of the control plane.")
  public String getNamespace() {
    return namespace;
  }

  public void setNamespace(String namespace) {
    this.namespace = namespace;
  }

  public ApiControlPlane dnsSuffix(String dnsSuffix) {
    this.dnsSuffix = dnsSuffix;
    return this;
  }

   /**
   * The domain where the control plane is installed. Append the domain to the namespace to get the url of the control plane.
   * @return dnsSuffix
  **/
  @ApiModelProperty(value = "The domain where the control plane is installed. Append the domain to the namespace to get the url of the control plane.")
  public String getDnsSuffix() {
    return dnsSuffix;
  }

  public void setDnsSuffix(String dnsSuffix) {
    this.dnsSuffix = dnsSuffix;
  }

  public ApiControlPlane uuid(String uuid) {
    this.uuid = uuid;
    return this;
  }

   /**
   * The universally unique ID of this control plane in Cloudera Manager
   * @return uuid
  **/
  @ApiModelProperty(value = "The universally unique ID of this control plane in Cloudera Manager")
  public String getUuid() {
    return uuid;
  }

  public void setUuid(String uuid) {
    this.uuid = uuid;
  }

  public ApiControlPlane remoteRepoUrl(String remoteRepoUrl) {
    this.remoteRepoUrl = remoteRepoUrl;
    return this;
  }

   /**
   * The url of the remote repository where the artifacts used to install the control plane are hosted
   * @return remoteRepoUrl
  **/
  @ApiModelProperty(value = "The url of the remote repository where the artifacts used to install the control plane are hosted")
  public String getRemoteRepoUrl() {
    return remoteRepoUrl;
  }

  public void setRemoteRepoUrl(String remoteRepoUrl) {
    this.remoteRepoUrl = remoteRepoUrl;
  }

  public ApiControlPlane version(String version) {
    this.version = version;
    return this;
  }

   /**
   * The CDP version of the control plane
   * @return version
  **/
  @ApiModelProperty(value = "The CDP version of the control plane")
  public String getVersion() {
    return version;
  }

  public void setVersion(String version) {
    this.version = version;
  }

  public ApiControlPlane manifest(String manifest) {
    this.manifest = manifest;
    return this;
  }

   /**
   * The content of the manifest.json of the control plane
   * @return manifest
  **/
  @ApiModelProperty(value = "The content of the manifest.json of the control plane")
  public String getManifest() {
    return manifest;
  }

  public void setManifest(String manifest) {
    this.manifest = manifest;
  }

  public ApiControlPlane valuesYaml(String valuesYaml) {
    this.valuesYaml = valuesYaml;
    return this;
  }

   /**
   * The content of the values.yaml used to configure the control plane
   * @return valuesYaml
  **/
  @ApiModelProperty(value = "The content of the values.yaml used to configure the control plane")
  public String getValuesYaml() {
    return valuesYaml;
  }

  public void setValuesYaml(String valuesYaml) {
    this.valuesYaml = valuesYaml;
  }

  public ApiControlPlane tags(List<ApiEntityTag> tags) {
    this.tags = tags;
    return this;
  }

  public ApiControlPlane addTagsItem(ApiEntityTag tagsItem) {
    if (this.tags == null) {
      this.tags = new ArrayList<ApiEntityTag>();
    }
    this.tags.add(tagsItem);
    return this;
  }

   /**
   * Tags associated with the control plane. Available since V46.
   * @return tags
  **/
  @ApiModelProperty(value = "Tags associated with the control plane. Available since V46.")
  public List<ApiEntityTag> getTags() {
    return tags;
  }

  public void setTags(List<ApiEntityTag> tags) {
    this.tags = tags;
  }

  public ApiControlPlane kubernetesType(String kubernetesType) {
    this.kubernetesType = kubernetesType;
    return this;
  }

   /**
   * The kubernetes type on which the control plane is running
   * @return kubernetesType
  **/
  @ApiModelProperty(value = "The kubernetes type on which the control plane is running")
  public String getKubernetesType() {
    return kubernetesType;
  }

  public void setKubernetesType(String kubernetesType) {
    this.kubernetesType = kubernetesType;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ApiControlPlane apiControlPlane = (ApiControlPlane) o;
    return Objects.equals(this.namespace, apiControlPlane.namespace) &&
        Objects.equals(this.dnsSuffix, apiControlPlane.dnsSuffix) &&
        Objects.equals(this.uuid, apiControlPlane.uuid) &&
        Objects.equals(this.remoteRepoUrl, apiControlPlane.remoteRepoUrl) &&
        Objects.equals(this.version, apiControlPlane.version) &&
        Objects.equals(this.manifest, apiControlPlane.manifest) &&
        Objects.equals(this.valuesYaml, apiControlPlane.valuesYaml) &&
        Objects.equals(this.tags, apiControlPlane.tags) &&
        Objects.equals(this.kubernetesType, apiControlPlane.kubernetesType);
  }

  @Override
  public int hashCode() {
    return Objects.hash(namespace, dnsSuffix, uuid, remoteRepoUrl, version, manifest, valuesYaml, tags, kubernetesType);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ApiControlPlane {\n");
    
    sb.append("    namespace: ").append(toIndentedString(namespace)).append("\n");
    sb.append("    dnsSuffix: ").append(toIndentedString(dnsSuffix)).append("\n");
    sb.append("    uuid: ").append(toIndentedString(uuid)).append("\n");
    sb.append("    remoteRepoUrl: ").append(toIndentedString(remoteRepoUrl)).append("\n");
    sb.append("    version: ").append(toIndentedString(version)).append("\n");
    sb.append("    manifest: ").append(toIndentedString(manifest)).append("\n");
    sb.append("    valuesYaml: ").append(toIndentedString(valuesYaml)).append("\n");
    sb.append("    tags: ").append(toIndentedString(tags)).append("\n");
    sb.append("    kubernetesType: ").append(toIndentedString(kubernetesType)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

