
# ApiReplicationSchedule

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**id** | **java.math.BigDecimal** | The schedule id. |  [optional]
**displayName** | **String** | The schedule display name. |  [optional]
**description** | **String** | The schedule description. |  [optional]
**startTime** | **String** | The time at which the scheduled activity is triggered for the first time. |  [optional]
**endTime** | **String** | The time after which the scheduled activity will no longer be triggered. |  [optional]
**interval** | **java.math.BigDecimal** | The duration between consecutive triggers of a scheduled activity. Defaults to 0. |  [optional]
**intervalUnit** | [**ApiScheduleInterval**](ApiScheduleInterval.md) | The unit for the repeat interval. |  [optional]
**nextRun** | **String** | Readonly. The time the scheduled command will run next. |  [optional]
**paused** | **Boolean** | The paused state for the schedule. The scheduled activity will not be triggered as long as the scheduled is paused. Defaults to false. |  [optional]
**alertOnStart** | **Boolean** | Whether to alert on start of the scheduled activity. Defaults to false. |  [optional]
**alertOnSuccess** | **Boolean** | Whether to alert on successful completion of the scheduled activity. Defaults to false. |  [optional]
**alertOnFail** | **Boolean** | Whether to alert on failure of the scheduled activity. Defaults to false. |  [optional]
**alertOnAbort** | **Boolean** | Whether to alert on abort of the scheduled activity. Defaults to false. |  [optional]
**hdfsArguments** | [**ApiHdfsReplicationArguments**](ApiHdfsReplicationArguments.md) | Optional arguments for HDFS replication commands. |  [optional]
**hiveArguments** | [**ApiHiveReplicationArguments**](ApiHiveReplicationArguments.md) | Optional arguments for Hive replication commands. |  [optional]
**hdfsCloudArguments** | [**ApiHdfsCloudReplicationArguments**](ApiHdfsCloudReplicationArguments.md) | Optional arguments for HDFS cloud replication commands. |  [optional]
**ozoneReplicationArguments** | [**ApiOzoneReplicationArguments**](ApiOzoneReplicationArguments.md) | Optional arguments for HDFS cloud replication commands. |  [optional]
**history** | [**List&lt;ApiReplicationCommand&gt;**](ApiReplicationCommand.md) | List of active and/or finished commands for this schedule. |  [optional]
**active** | **Boolean** | Read-only field that is true if this schedule is currently active, false if not. Available since API v11. |  [optional]
**hiveCloudArguments** | [**ApiHiveCloudReplicationArguments**](ApiHiveCloudReplicationArguments.md) | Optional arguments for Hive cloud replication commands. |  [optional]
**hbaseArguments** | [**ApiHBaseReplicationArguments**](ApiHBaseReplicationArguments.md) | Optional arguments for HBase replication commands. |  [optional]
**hive3Arguments** | [**ApiHive3ReplicationArguments**](ApiHive3ReplicationArguments.md) | arguments for Hive3 schedules |  [optional]
**rangerArguments** | [**ApiRangerReplicationArgs**](ApiRangerReplicationArgs.md) | Optional arguments for Ranger replication. |  [optional]



