# CspResourceApi

All URIs are relative to *https://localhost/api/v51*

Method | HTTP request | Description
------------- | ------------- | -------------
[**uploadCspCert**](CspResourceApi.md#uploadCspCert) | **PUT** /csp/uploadCspCert | Upload CA certificates, client certificates and client key for Credential Storage Provider.


<a name="uploadCspCert"></a>
# **uploadCspCert**
> ApiCspArguments uploadCspCert(body)

Upload CA certificates, client certificates and client key for Credential Storage Provider.

Upload CA certificates, client certificates and client key for Credential Storage Provider. CM server restart is needed for these certificates to be applied.

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.CspResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

CspResourceApi apiInstance = new CspResourceApi();
ApiCspArguments body = new ApiCspArguments(); // ApiCspArguments | Arguments for the CSP
try {
    ApiCspArguments result = apiInstance.uploadCspCert(body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling CspResourceApi#uploadCspCert");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**ApiCspArguments**](ApiCspArguments.md)| Arguments for the CSP | [optional]

### Return type

[**ApiCspArguments**](ApiCspArguments.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

