# ReplicationsResourceApi

All URIs are relative to *https://localhost/api/v51*

Method | HTTP request | Description
------------- | ------------- | -------------
[**addHBaseReplicationPeer**](ReplicationsResourceApi.md#addHBaseReplicationPeer) | **POST** /clusters/{clusterName}/services/{serviceName}/replications/operations/addReplicationPeer | Starts a command that adds a new replication peer to HBase.
[**addTablesToHBasePeer**](ReplicationsResourceApi.md#addTablesToHBasePeer) | **POST** /clusters/{clusterName}/services/{serviceName}/replications/operations/addTablesToHBasePeer | Starts a command that adds tables and column families to an existing HBase replication peer.
[**checkHBaseTablesExist**](ReplicationsResourceApi.md#checkHBaseTablesExist) | **POST** /clusters/{clusterName}/services/{serviceName}/replications/operations/checkTables | Starts a command that checks if the specified tables exist in HBase.
[**collectDiagnosticData**](ReplicationsResourceApi.md#collectDiagnosticData) | **POST** /clusters/{clusterName}/services/{serviceName}/replications/{scheduleId}/collectDiagnosticData | Collect diagnostic data for a schedule, optionally for a subset of commands on that schedule, matched by schedule ID.
[**createCloudCredstoreOnHdfs**](ReplicationsResourceApi.md#createCloudCredstoreOnHdfs) | **POST** /clusters/{clusterName}/services/{serviceName}/replications/createCloudCredstoreOnHdfs | Creates a credstore provider jceks file on HDFS for the given service.
[**createCredstore**](ReplicationsResourceApi.md#createCredstore) | **POST** /clusters/{clusterName}/services/{serviceName}/replications/createCredstore | Use the following API endpoint instead:.
[**createHBaseTable**](ReplicationsResourceApi.md#createHBaseTable) | **POST** /clusters/{clusterName}/services/{serviceName}/replications/operations/createTable | Starts a command that creates a new table in HBase.
[**createSchedules**](ReplicationsResourceApi.md#createSchedules) | **POST** /clusters/{clusterName}/services/{serviceName}/replications | Creates one or more replication schedules.
[**deleteAllSchedules**](ReplicationsResourceApi.md#deleteAllSchedules) | **DELETE** /clusters/{clusterName}/services/{serviceName}/replications | Deletes all existing replication schedules.
[**deleteSchedule**](ReplicationsResourceApi.md#deleteSchedule) | **DELETE** /clusters/{clusterName}/services/{serviceName}/replications/{scheduleId} | Deletes an existing replication schedule.
[**exportRangerServices**](ReplicationsResourceApi.md#exportRangerServices) | **POST** /clusters/{clusterName}/services/{serviceName}/replications/exportRangerServices | Exports the given Ranger services and policies (defined in the API body) to a zipped file.
[**fetchHBaseColumnFamilies**](ReplicationsResourceApi.md#fetchHBaseColumnFamilies) | **POST** /clusters/{clusterName}/services/{serviceName}/replications/operations/fetchColumnFamilies | Starts a command that fetches column families for the desired tables.
[**fetchHBasePeerInfo**](ReplicationsResourceApi.md#fetchHBasePeerInfo) | **POST** /clusters/{clusterName}/services/{serviceName}/replications/operations/fetchHBasePeerInfo | Starts a command that fetches information about an HBase peer by its ID.
[**forceDeleteSchedule**](ReplicationsResourceApi.md#forceDeleteSchedule) | **DELETE** /clusters/{clusterName}/services/{serviceName}/replications/{scheduleId}/forcedDelete | Deletes an existing replication schedule only from the DB.
[**generateCloudReplCredstorePassword**](ReplicationsResourceApi.md#generateCloudReplCredstorePassword) | **POST** /clusters/{clusterName}/services/{serviceName}/replications/generateCloudReplCredstorePassword | (Re)generates the cloud credential provider password, used by the given service, for replicating to the cloud.
[**getReplicationState**](ReplicationsResourceApi.md#getReplicationState) | **GET** /clusters/{clusterName}/services/{serviceName}/replications/replicationState | returns the replication state.
[**isHive3ReverseDirectionEnabled**](ReplicationsResourceApi.md#isHive3ReverseDirectionEnabled) | **GET** /clusters/{clusterName}/services/{serviceName}/replications/isHive3ReverseDirectionEnabled | This API endpoint checks if there is an ENABLED Hive3 replication policy on this server that replicates for the reverse direction.
[**listHBaseNamespaces**](ReplicationsResourceApi.md#listHBaseNamespaces) | **GET** /clusters/{clusterName}/services/{serviceName}/replications/operations/listNamespaces | Starts a command that lists all namespaces in HBase.
[**listHBasePeers**](ReplicationsResourceApi.md#listHBasePeers) | **GET** /clusters/{clusterName}/services/{serviceName}/replications/operations/listPeers | Starts a command that retrieves all peers registered in the HBase service.
[**listHBaseTables**](ReplicationsResourceApi.md#listHBaseTables) | **GET** /clusters/{clusterName}/services/{serviceName}/replications/operations/listTables | Starts a command that lists tables from the HBase service.
[**readHistory**](ReplicationsResourceApi.md#readHistory) | **GET** /clusters/{clusterName}/services/{serviceName}/replications/{scheduleId}/history | Returns a list of commands triggered by a schedule.
[**readSchedule**](ReplicationsResourceApi.md#readSchedule) | **GET** /clusters/{clusterName}/services/{serviceName}/replications/{scheduleId} | Returns information for a specific replication schedule.
[**readSchedules**](ReplicationsResourceApi.md#readSchedules) | **GET** /clusters/{clusterName}/services/{serviceName}/replications | Retrieves information about replication schedules.
[**recreateCloudCredstoresOnHdfs**](ReplicationsResourceApi.md#recreateCloudCredstoresOnHdfs) | **POST** /clusters/{clusterName}/services/{serviceName}/replications/recreateCloudCredstoresOnHdfs | Recreates the existing credential provider jceks files on HDFS, that are used by the given service, for replicating to the cloud.
[**removeHBasePeer**](ReplicationsResourceApi.md#removeHBasePeer) | **POST** /clusters/{clusterName}/services/{serviceName}/replications/operations/removeHBasePeer | Starts a command that removes the specified HBase replication peer from the local HBase service.
[**removeTablesFromHBasePeer**](ReplicationsResourceApi.md#removeTablesFromHBasePeer) | **POST** /clusters/{clusterName}/services/{serviceName}/replications/operations/removeTablesFromHBasePeer | Starts a command that removes tables and column families from an existing HBase replication peer.
[**rescheduleHive3ReplicationMetricsGetter**](ReplicationsResourceApi.md#rescheduleHive3ReplicationMetricsGetter) | **POST** /clusters/{clusterName}/services/{serviceName}/replications/rescheduleHive3ReplicationMetricsGetter | Set the Hive3 Replication Metrics Getter next start time.
[**runCopyListing**](ReplicationsResourceApi.md#runCopyListing) | **POST** /clusters/{clusterName}/services/{serviceName}/replications/hdfsCopyListing | Run the hdfs copy listing command.
[**runHBaseReplicationRetryFailedSnapshots**](ReplicationsResourceApi.md#runHBaseReplicationRetryFailedSnapshots) | **POST** /clusters/{clusterName}/services/{serviceName}/replications/{scheduleId}/runHBaseReplicationRetryFailedSnapshots | Executes a command to run a HBase replication retry on failed snapshots for the given schedule ID.
[**runHBaseReplicationSecurityTool**](ReplicationsResourceApi.md#runHBaseReplicationSecurityTool) | **POST** /clusters/{clusterName}/services/{serviceName}/replications/hbaseReplicationSecurityTool | Run the hbase replication security tool.
[**runHBaseReplicationValidationTool**](ReplicationsResourceApi.md#runHBaseReplicationValidationTool) | **POST** /clusters/{clusterName}/services/{serviceName}/replications/hbaseReplicationValidationTool | Executes a command, which validates if HBase replication works properly for the given hbasePeerId.
[**runHiveReplicationQuery**](ReplicationsResourceApi.md#runHiveReplicationQuery) | **POST** /clusters/{clusterName}/services/{serviceName}/replications/hiveReplicationQuery | Execute a hive replication query on local HS2 service instance.
[**runSchedule**](ReplicationsResourceApi.md#runSchedule) | **POST** /clusters/{clusterName}/services/{serviceName}/replications/{scheduleId}/run | Run the schedule immediately.
[**setCFsReplicationScope**](ReplicationsResourceApi.md#setCFsReplicationScope) | **POST** /clusters/{clusterName}/services/{serviceName}/replications/operations/setCFsReplicationScope | Starts a command that set the replication scope of the provided column families to the desired value.
[**updateHBasePeerState**](ReplicationsResourceApi.md#updateHBasePeerState) | **PUT** /clusters/{clusterName}/services/{serviceName}/replications/updateHBasePeerState | Update HBase peer state (&#39;DISABLE&#39; or &#39;ENABLE&#39;),.
[**updateHBaseReplicationPeerState**](ReplicationsResourceApi.md#updateHBaseReplicationPeerState) | **POST** /clusters/{clusterName}/services/{serviceName}/replications/operations/updateReplicationPeerState | Starts a command that updates the state of an existing HBase replication peer.
[**updateSchedule**](ReplicationsResourceApi.md#updateSchedule) | **PUT** /clusters/{clusterName}/services/{serviceName}/replications/{scheduleId} | Updates an existing replication schedule.


<a name="addHBaseReplicationPeer"></a>
# **addHBaseReplicationPeer**
> ApiCommand addHBaseReplicationPeer(clusterName, serviceName, body)

Starts a command that adds a new replication peer to HBase.

Starts a command that adds a new replication peer to HBase.

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ReplicationsResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ReplicationsResourceApi apiInstance = new ReplicationsResourceApi();
String clusterName = "clusterName_example"; // String | 
String serviceName = "serviceName_example"; // String | The service name.
ApiHBaseAddReplicationPeerInput body = new ApiHBaseAddReplicationPeerInput(); // ApiHBaseAddReplicationPeerInput | Information for peer creation.
try {
    ApiCommand result = apiInstance.addHBaseReplicationPeer(clusterName, serviceName, body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReplicationsResourceApi#addHBaseReplicationPeer");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clusterName** | **String**|  |
 **serviceName** | **String**| The service name. |
 **body** | [**ApiHBaseAddReplicationPeerInput**](ApiHBaseAddReplicationPeerInput.md)| Information for peer creation. | [optional]

### Return type

[**ApiCommand**](ApiCommand.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="addTablesToHBasePeer"></a>
# **addTablesToHBasePeer**
> ApiCommand addTablesToHBasePeer(clusterName, serviceName, body)

Starts a command that adds tables and column families to an existing HBase replication peer.

Starts a command that adds tables and column families to an existing HBase replication peer.

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ReplicationsResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ReplicationsResourceApi apiInstance = new ReplicationsResourceApi();
String clusterName = "clusterName_example"; // String | 
String serviceName = "serviceName_example"; // String | The service name.
ApiHBasePeerIdWithTableCFs body = new ApiHBasePeerIdWithTableCFs(); // ApiHBasePeerIdWithTableCFs | Arguments for the operation.
try {
    ApiCommand result = apiInstance.addTablesToHBasePeer(clusterName, serviceName, body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReplicationsResourceApi#addTablesToHBasePeer");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clusterName** | **String**|  |
 **serviceName** | **String**| The service name. |
 **body** | [**ApiHBasePeerIdWithTableCFs**](ApiHBasePeerIdWithTableCFs.md)| Arguments for the operation. | [optional]

### Return type

[**ApiCommand**](ApiCommand.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="checkHBaseTablesExist"></a>
# **checkHBaseTablesExist**
> ApiCommand checkHBaseTablesExist(clusterName, serviceName, body)

Starts a command that checks if the specified tables exist in HBase.

Starts a command that checks if the specified tables exist in HBase.

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ReplicationsResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ReplicationsResourceApi apiInstance = new ReplicationsResourceApi();
String clusterName = "clusterName_example"; // String | 
String serviceName = "serviceName_example"; // String | The service name.
ApiHBaseTableNames body = new ApiHBaseTableNames(); // ApiHBaseTableNames | Names of the tables to be checked.
try {
    ApiCommand result = apiInstance.checkHBaseTablesExist(clusterName, serviceName, body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReplicationsResourceApi#checkHBaseTablesExist");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clusterName** | **String**|  |
 **serviceName** | **String**| The service name. |
 **body** | [**ApiHBaseTableNames**](ApiHBaseTableNames.md)| Names of the tables to be checked. | [optional]

### Return type

[**ApiCommand**](ApiCommand.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="collectDiagnosticData"></a>
# **collectDiagnosticData**
> ApiCommand collectDiagnosticData(clusterName, scheduleId, serviceName, view, body)

Collect diagnostic data for a schedule, optionally for a subset of commands on that schedule, matched by schedule ID.

Collect diagnostic data for a schedule, optionally for a subset of commands on that schedule, matched by schedule ID.  The returned command's resultDataUrl property, upon the commands completion, will refer to the generated diagnostic data. Available since API v11.

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ReplicationsResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ReplicationsResourceApi apiInstance = new ReplicationsResourceApi();
String clusterName = "clusterName_example"; // String | 
java.math.BigDecimal scheduleId = new java.math.BigDecimal(); // java.math.BigDecimal | Schedule ID
String serviceName = "serviceName_example"; // String | The service name.
String view = "summary"; // String | view to materialize
ApiReplicationDiagnosticsCollectionArgs body = new ApiReplicationDiagnosticsCollectionArgs(); // ApiReplicationDiagnosticsCollectionArgs | Replication collection arguments
try {
    ApiCommand result = apiInstance.collectDiagnosticData(clusterName, scheduleId, serviceName, view, body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReplicationsResourceApi#collectDiagnosticData");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clusterName** | **String**|  |
 **scheduleId** | **java.math.BigDecimal**| Schedule ID |
 **serviceName** | **String**| The service name. |
 **view** | **String**| view to materialize | [optional] [default to summary] [enum: EXPORT, EXPORT_REDACTED, FULL, FULL_WITH_HEALTH_CHECK_EXPLANATION, SUMMARY]
 **body** | [**ApiReplicationDiagnosticsCollectionArgs**](ApiReplicationDiagnosticsCollectionArgs.md)| Replication collection arguments | [optional]

### Return type

[**ApiCommand**](ApiCommand.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="createCloudCredstoreOnHdfs"></a>
# **createCloudCredstoreOnHdfs**
> ApiCommand createCloudCredstoreOnHdfs(clusterName, serviceName, force, sourceAccount)

Creates a credstore provider jceks file on HDFS for the given service.

Creates a credstore provider jceks file on HDFS for the given service. The file will store credential information for the given sourceAccount.

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ReplicationsResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ReplicationsResourceApi apiInstance = new ReplicationsResourceApi();
String clusterName = "clusterName_example"; // String | 
String serviceName = "serviceName_example"; // String | The service name.
Boolean force = true; // Boolean | if the jceks file already exists on HDFS and this parameter is set to true then it will be recreated, otherwise left untouched
String sourceAccount = "sourceAccount_example"; // String | the External Account that has been already added to this CM, for which the credstore provider jceks file will be generated
try {
    ApiCommand result = apiInstance.createCloudCredstoreOnHdfs(clusterName, serviceName, force, sourceAccount);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReplicationsResourceApi#createCloudCredstoreOnHdfs");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clusterName** | **String**|  |
 **serviceName** | **String**| The service name. |
 **force** | **Boolean**| if the jceks file already exists on HDFS and this parameter is set to true then it will be recreated, otherwise left untouched | [optional]
 **sourceAccount** | **String**| the External Account that has been already added to this CM, for which the credstore provider jceks file will be generated | [optional]

### Return type

[**ApiCommand**](ApiCommand.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="createCredstore"></a>
# **createCredstore**
> ApiCommand createCredstore(clusterName, serviceName, credstoreDirPath, force, sourceAccount)

Use the following API endpoint instead:.

Use the following API endpoint instead: <b/> com.cloudera.api.v50.ReplicationsResourceV50#createCloudCredstoreOnHdfs(String, boolean)

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ReplicationsResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ReplicationsResourceApi apiInstance = new ReplicationsResourceApi();
String clusterName = "clusterName_example"; // String | 
String serviceName = "serviceName_example"; // String | The service name.
String credstoreDirPath = "credstoreDirPath_example"; // String | 
Boolean force = true; // Boolean | 
String sourceAccount = "sourceAccount_example"; // String | 
try {
    ApiCommand result = apiInstance.createCredstore(clusterName, serviceName, credstoreDirPath, force, sourceAccount);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReplicationsResourceApi#createCredstore");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clusterName** | **String**|  |
 **serviceName** | **String**| The service name. |
 **credstoreDirPath** | **String**|  | [optional]
 **force** | **Boolean**|  | [optional]
 **sourceAccount** | **String**|  | [optional]

### Return type

[**ApiCommand**](ApiCommand.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="createHBaseTable"></a>
# **createHBaseTable**
> ApiCommand createHBaseTable(clusterName, serviceName, body)

Starts a command that creates a new table in HBase.

Starts a command that creates a new table in HBase.

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ReplicationsResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ReplicationsResourceApi apiInstance = new ReplicationsResourceApi();
String clusterName = "clusterName_example"; // String | 
String serviceName = "serviceName_example"; // String | The service name.
ApiHBaseCreateTable body = new ApiHBaseCreateTable(); // ApiHBaseCreateTable | Arguments for table creation.
try {
    ApiCommand result = apiInstance.createHBaseTable(clusterName, serviceName, body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReplicationsResourceApi#createHBaseTable");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clusterName** | **String**|  |
 **serviceName** | **String**| The service name. |
 **body** | [**ApiHBaseCreateTable**](ApiHBaseCreateTable.md)| Arguments for table creation. | [optional]

### Return type

[**ApiCommand**](ApiCommand.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="createSchedules"></a>
# **createSchedules**
> ApiReplicationScheduleList createSchedules(clusterName, serviceName, body)

Creates one or more replication schedules.

Creates one or more replication schedules. <p> Available since API v3. Only available with Cloudera Manager Enterprise Edition.

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ReplicationsResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ReplicationsResourceApi apiInstance = new ReplicationsResourceApi();
String clusterName = "clusterName_example"; // String | 
String serviceName = "serviceName_example"; // String | The service name.
ApiReplicationScheduleList body = new ApiReplicationScheduleList(); // ApiReplicationScheduleList | List of the replication schedules to create.
try {
    ApiReplicationScheduleList result = apiInstance.createSchedules(clusterName, serviceName, body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReplicationsResourceApi#createSchedules");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clusterName** | **String**|  |
 **serviceName** | **String**| The service name. |
 **body** | [**ApiReplicationScheduleList**](ApiReplicationScheduleList.md)| List of the replication schedules to create. | [optional]

### Return type

[**ApiReplicationScheduleList**](ApiReplicationScheduleList.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="deleteAllSchedules"></a>
# **deleteAllSchedules**
> ApiReplicationScheduleList deleteAllSchedules(clusterName, serviceName)

Deletes all existing replication schedules.

Deletes all existing replication schedules. <p> Available since API v3. Only available with Cloudera Manager Enterprise Edition.

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ReplicationsResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ReplicationsResourceApi apiInstance = new ReplicationsResourceApi();
String clusterName = "clusterName_example"; // String | 
String serviceName = "serviceName_example"; // String | The service name.
try {
    ApiReplicationScheduleList result = apiInstance.deleteAllSchedules(clusterName, serviceName);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReplicationsResourceApi#deleteAllSchedules");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clusterName** | **String**|  |
 **serviceName** | **String**| The service name. |

### Return type

[**ApiReplicationScheduleList**](ApiReplicationScheduleList.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="deleteSchedule"></a>
# **deleteSchedule**
> ApiReplicationSchedule deleteSchedule(clusterName, scheduleId, serviceName)

Deletes an existing replication schedule.

Deletes an existing replication schedule. <p> Available since API v3. Only available with Cloudera Manager Enterprise Edition.

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ReplicationsResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ReplicationsResourceApi apiInstance = new ReplicationsResourceApi();
String clusterName = "clusterName_example"; // String | 
java.math.BigDecimal scheduleId = new java.math.BigDecimal(); // java.math.BigDecimal | Id of an existing replication schedule.
String serviceName = "serviceName_example"; // String | The service name.
try {
    ApiReplicationSchedule result = apiInstance.deleteSchedule(clusterName, scheduleId, serviceName);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReplicationsResourceApi#deleteSchedule");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clusterName** | **String**|  |
 **scheduleId** | **java.math.BigDecimal**| Id of an existing replication schedule. |
 **serviceName** | **String**| The service name. |

### Return type

[**ApiReplicationSchedule**](ApiReplicationSchedule.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="exportRangerServices"></a>
# **exportRangerServices**
> ApiCommand exportRangerServices(clusterName, serviceName, body)

Exports the given Ranger services and policies (defined in the API body) to a zipped file.

Exports the given Ranger services and policies (defined in the API body) to a zipped file.

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ReplicationsResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ReplicationsResourceApi apiInstance = new ReplicationsResourceApi();
String clusterName = "clusterName_example"; // String | 
String serviceName = "serviceName_example"; // String | The service name.
ApiRangerReplicationExportArgs body = new ApiRangerReplicationExportArgs(); // ApiRangerReplicationExportArgs | the arguments for the export operation. Contains the Ranger services to be exported.
try {
    ApiCommand result = apiInstance.exportRangerServices(clusterName, serviceName, body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReplicationsResourceApi#exportRangerServices");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clusterName** | **String**|  |
 **serviceName** | **String**| The service name. |
 **body** | [**ApiRangerReplicationExportArgs**](ApiRangerReplicationExportArgs.md)| the arguments for the export operation. Contains the Ranger services to be exported. | [optional]

### Return type

[**ApiCommand**](ApiCommand.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="fetchHBaseColumnFamilies"></a>
# **fetchHBaseColumnFamilies**
> ApiCommand fetchHBaseColumnFamilies(clusterName, serviceName, body)

Starts a command that fetches column families for the desired tables.

Starts a command that fetches column families for the desired tables.

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ReplicationsResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ReplicationsResourceApi apiInstance = new ReplicationsResourceApi();
String clusterName = "clusterName_example"; // String | 
String serviceName = "serviceName_example"; // String | The service name.
ApiHBaseTableNames body = new ApiHBaseTableNames(); // ApiHBaseTableNames | Names of tables to query for column families.
try {
    ApiCommand result = apiInstance.fetchHBaseColumnFamilies(clusterName, serviceName, body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReplicationsResourceApi#fetchHBaseColumnFamilies");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clusterName** | **String**|  |
 **serviceName** | **String**| The service name. |
 **body** | [**ApiHBaseTableNames**](ApiHBaseTableNames.md)| Names of tables to query for column families. | [optional]

### Return type

[**ApiCommand**](ApiCommand.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="fetchHBasePeerInfo"></a>
# **fetchHBasePeerInfo**
> ApiCommand fetchHBasePeerInfo(clusterName, serviceName, body)

Starts a command that fetches information about an HBase peer by its ID.

Starts a command that fetches information about an HBase peer by its ID.

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ReplicationsResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ReplicationsResourceApi apiInstance = new ReplicationsResourceApi();
String clusterName = "clusterName_example"; // String | 
String serviceName = "serviceName_example"; // String | The service name.
ApiHBasePeerId body = new ApiHBasePeerId(); // ApiHBasePeerId | ID of the fetched peer.
try {
    ApiCommand result = apiInstance.fetchHBasePeerInfo(clusterName, serviceName, body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReplicationsResourceApi#fetchHBasePeerInfo");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clusterName** | **String**|  |
 **serviceName** | **String**| The service name. |
 **body** | [**ApiHBasePeerId**](ApiHBasePeerId.md)| ID of the fetched peer. | [optional]

### Return type

[**ApiCommand**](ApiCommand.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="forceDeleteSchedule"></a>
# **forceDeleteSchedule**
> ApiReplicationSchedule forceDeleteSchedule(clusterName, scheduleId, serviceName)

Deletes an existing replication schedule only from the DB.

Deletes an existing replication schedule only from the DB. <p> Only the DB schedule reference is deleted with no further cleanup on the source or target side. Typically this endpoint can be used when the source cluster is not available any more and normal policy delete fails during cleanup.  Available since API v46. Only available with Cloudera Manager Enterprise Edition.

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ReplicationsResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ReplicationsResourceApi apiInstance = new ReplicationsResourceApi();
String clusterName = "clusterName_example"; // String | 
java.math.BigDecimal scheduleId = new java.math.BigDecimal(); // java.math.BigDecimal | Id of an existing replication schedule.
String serviceName = "serviceName_example"; // String | The service name.
try {
    ApiReplicationSchedule result = apiInstance.forceDeleteSchedule(clusterName, scheduleId, serviceName);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReplicationsResourceApi#forceDeleteSchedule");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clusterName** | **String**|  |
 **scheduleId** | **java.math.BigDecimal**| Id of an existing replication schedule. |
 **serviceName** | **String**| The service name. |

### Return type

[**ApiReplicationSchedule**](ApiReplicationSchedule.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="generateCloudReplCredstorePassword"></a>
# **generateCloudReplCredstorePassword**
> Boolean generateCloudReplCredstorePassword(clusterName, serviceName, passwordGenerateMode)

(Re)generates the cloud credential provider password, used by the given service, for replicating to the cloud.

(Re)generates the cloud credential provider password, used by the given service, for replicating to the cloud. <br/> Calling this API endpoint may cause staleness for the given service. <br/> NOTE: If this API endpoint REGENERATED the credstore password successfully and there are existing credstore provider jceks files on HDFS, protected by this password, then these jceks files should be recreated by using the following API endpoint: #recreateCloudCredstoresOnHdfs().

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ReplicationsResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ReplicationsResourceApi apiInstance = new ReplicationsResourceApi();
String clusterName = "clusterName_example"; // String | 
String serviceName = "serviceName_example"; // String | The service name.
String passwordGenerateMode = "passwordGenerateMode_example"; // String | the CloudReplPasswordGenerateMode to be used for regenerating the password.
try {
    Boolean result = apiInstance.generateCloudReplCredstorePassword(clusterName, serviceName, passwordGenerateMode);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReplicationsResourceApi#generateCloudReplCredstorePassword");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clusterName** | **String**|  |
 **serviceName** | **String**| The service name. |
 **passwordGenerateMode** | **String**| the CloudReplPasswordGenerateMode to be used for regenerating the password. | [optional] [enum: FORCE, GENERATE_IF_NULL, REGENERATE_IF_SET]

### Return type

**Boolean**

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getReplicationState"></a>
# **getReplicationState**
> ApiReplicationState getReplicationState(clusterName, serviceName, view)

returns the replication state.

returns the replication state. for example if incremental export is enabled, etc

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ReplicationsResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ReplicationsResourceApi apiInstance = new ReplicationsResourceApi();
String clusterName = "clusterName_example"; // String | 
String serviceName = "serviceName_example"; // String | The service name.
String view = "summary"; // String | view to materialize
try {
    ApiReplicationState result = apiInstance.getReplicationState(clusterName, serviceName, view);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReplicationsResourceApi#getReplicationState");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clusterName** | **String**|  |
 **serviceName** | **String**| The service name. |
 **view** | **String**| view to materialize | [optional] [default to summary] [enum: EXPORT, EXPORT_REDACTED, FULL, FULL_WITH_HEALTH_CHECK_EXPLANATION, SUMMARY]

### Return type

[**ApiReplicationState**](ApiReplicationState.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="isHive3ReverseDirectionEnabled"></a>
# **isHive3ReverseDirectionEnabled**
> Boolean isHive3ReverseDirectionEnabled(clusterName, serviceName, clusterUuidOnRemote, serviceNameOnRemote, sourceDbNameOnRemote, targetDbNameOnRemote)

This API endpoint checks if there is an ENABLED Hive3 replication policy on this server that replicates for the reverse direction.

This API endpoint checks if there is an ENABLED Hive3 replication policy on this server that replicates for the reverse direction. Bidirectional Hive3 replication policies are allowed, but only one direction can be ENABLED at the same time.

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ReplicationsResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ReplicationsResourceApi apiInstance = new ReplicationsResourceApi();
String clusterName = "clusterName_example"; // String | 
String serviceName = "serviceName_example"; // String | The service name.
String clusterUuidOnRemote = "clusterUuidOnRemote_example"; // String | the uuid of the cluster on the remote CM server
String serviceNameOnRemote = "serviceNameOnRemote_example"; // String | the Hive3 service name on the remote CM server, more specifically on the cluster specified by clusterUuidOnRemote
String sourceDbNameOnRemote = "sourceDbNameOnRemote_example"; // String | the name of the source database on the remote CM server
String targetDbNameOnRemote = "targetDbNameOnRemote_example"; // String | the name of the target database on the remote CM server
try {
    Boolean result = apiInstance.isHive3ReverseDirectionEnabled(clusterName, serviceName, clusterUuidOnRemote, serviceNameOnRemote, sourceDbNameOnRemote, targetDbNameOnRemote);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReplicationsResourceApi#isHive3ReverseDirectionEnabled");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clusterName** | **String**|  |
 **serviceName** | **String**| The service name. |
 **clusterUuidOnRemote** | **String**| the uuid of the cluster on the remote CM server | [optional]
 **serviceNameOnRemote** | **String**| the Hive3 service name on the remote CM server, more specifically on the cluster specified by clusterUuidOnRemote | [optional]
 **sourceDbNameOnRemote** | **String**| the name of the source database on the remote CM server | [optional]
 **targetDbNameOnRemote** | **String**| the name of the target database on the remote CM server | [optional]

### Return type

**Boolean**

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="listHBaseNamespaces"></a>
# **listHBaseNamespaces**
> ApiCommand listHBaseNamespaces(clusterName, serviceName)

Starts a command that lists all namespaces in HBase.

Starts a command that lists all namespaces in HBase.

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ReplicationsResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ReplicationsResourceApi apiInstance = new ReplicationsResourceApi();
String clusterName = "clusterName_example"; // String | 
String serviceName = "serviceName_example"; // String | The service name.
try {
    ApiCommand result = apiInstance.listHBaseNamespaces(clusterName, serviceName);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReplicationsResourceApi#listHBaseNamespaces");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clusterName** | **String**|  |
 **serviceName** | **String**| The service name. |

### Return type

[**ApiCommand**](ApiCommand.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="listHBasePeers"></a>
# **listHBasePeers**
> ApiCommand listHBasePeers(clusterName, serviceName)

Starts a command that retrieves all peers registered in the HBase service.

Starts a command that retrieves all peers registered in the HBase service.

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ReplicationsResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ReplicationsResourceApi apiInstance = new ReplicationsResourceApi();
String clusterName = "clusterName_example"; // String | 
String serviceName = "serviceName_example"; // String | The service name.
try {
    ApiCommand result = apiInstance.listHBasePeers(clusterName, serviceName);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReplicationsResourceApi#listHBasePeers");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clusterName** | **String**|  |
 **serviceName** | **String**| The service name. |

### Return type

[**ApiCommand**](ApiCommand.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="listHBaseTables"></a>
# **listHBaseTables**
> ApiCommand listHBaseTables(clusterName, serviceName)

Starts a command that lists tables from the HBase service.

Starts a command that lists tables from the HBase service.

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ReplicationsResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ReplicationsResourceApi apiInstance = new ReplicationsResourceApi();
String clusterName = "clusterName_example"; // String | 
String serviceName = "serviceName_example"; // String | The service name.
try {
    ApiCommand result = apiInstance.listHBaseTables(clusterName, serviceName);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReplicationsResourceApi#listHBaseTables");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clusterName** | **String**|  |
 **serviceName** | **String**| The service name. |

### Return type

[**ApiCommand**](ApiCommand.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="readHistory"></a>
# **readHistory**
> ApiReplicationCommandList readHistory(clusterName, scheduleId, serviceName, limit, offset, view)

Returns a list of commands triggered by a schedule.

Returns a list of commands triggered by a schedule.

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ReplicationsResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ReplicationsResourceApi apiInstance = new ReplicationsResourceApi();
String clusterName = "clusterName_example"; // String | 
java.math.BigDecimal scheduleId = new java.math.BigDecimal(); // java.math.BigDecimal | Id of an existing replication schedule.
String serviceName = "serviceName_example"; // String | The service name.
java.math.BigDecimal limit = new java.math.BigDecimal(); // java.math.BigDecimal | Maximum number of commands to retrieve.
java.math.BigDecimal offset = new java.math.BigDecimal(); // java.math.BigDecimal | Index of first command to retrieve.
String view = "summary"; // String | The view to materialize.
try {
    ApiReplicationCommandList result = apiInstance.readHistory(clusterName, scheduleId, serviceName, limit, offset, view);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReplicationsResourceApi#readHistory");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clusterName** | **String**|  |
 **scheduleId** | **java.math.BigDecimal**| Id of an existing replication schedule. |
 **serviceName** | **String**| The service name. |
 **limit** | **java.math.BigDecimal**| Maximum number of commands to retrieve. | [optional] [default to 20]
 **offset** | **java.math.BigDecimal**| Index of first command to retrieve. | [optional] [default to 0]
 **view** | **String**| The view to materialize. | [optional] [default to summary] [enum: EXPORT, EXPORT_REDACTED, FULL, FULL_WITH_HEALTH_CHECK_EXPLANATION, SUMMARY]

### Return type

[**ApiReplicationCommandList**](ApiReplicationCommandList.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="readSchedule"></a>
# **readSchedule**
> ApiReplicationSchedule readSchedule(clusterName, scheduleId, serviceName, view)

Returns information for a specific replication schedule.

Returns information for a specific replication schedule. <p> Available since API v3. Only available with Cloudera Manager Enterprise Edition.

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ReplicationsResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ReplicationsResourceApi apiInstance = new ReplicationsResourceApi();
String clusterName = "clusterName_example"; // String | 
java.math.BigDecimal scheduleId = new java.math.BigDecimal(); // java.math.BigDecimal | Id of an existing replication schedule.
String serviceName = "serviceName_example"; // String | The service name.
String view = "summary"; // String | The view to materialize.
try {
    ApiReplicationSchedule result = apiInstance.readSchedule(clusterName, scheduleId, serviceName, view);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReplicationsResourceApi#readSchedule");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clusterName** | **String**|  |
 **scheduleId** | **java.math.BigDecimal**| Id of an existing replication schedule. |
 **serviceName** | **String**| The service name. |
 **view** | **String**| The view to materialize. | [optional] [default to summary] [enum: EXPORT, EXPORT_REDACTED, FULL, FULL_WITH_HEALTH_CHECK_EXPLANATION, SUMMARY]

### Return type

[**ApiReplicationSchedule**](ApiReplicationSchedule.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="readSchedules"></a>
# **readSchedules**
> ApiReplicationScheduleList readSchedules(clusterName, serviceName, maxCommands, maxErrors, maxSchedules, maxTables, view)

Retrieves information about replication schedules.

Retrieves information about replication schedules.

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ReplicationsResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ReplicationsResourceApi apiInstance = new ReplicationsResourceApi();
String clusterName = "clusterName_example"; // String | 
String serviceName = "serviceName_example"; // String | The service name.
java.math.BigDecimal maxCommands = new java.math.BigDecimal(); // java.math.BigDecimal | Maximum number of commands to include in the history of replication schedules. By default, it has no limit. Pass 0 to explicitly set to unlimited.
java.math.BigDecimal maxErrors = new java.math.BigDecimal(); // java.math.BigDecimal | Maximum number of errors per Hive replication command. By default, it has no limit. Pass 0 to explicitly set to unlimited.
java.math.BigDecimal maxSchedules = new java.math.BigDecimal(); // java.math.BigDecimal | Maximum number of replication schedules to be included in the response. By default, it has no limit. Pass 0 to explicitly set to unlimited.
java.math.BigDecimal maxTables = new java.math.BigDecimal(); // java.math.BigDecimal | Maximum number of tables per Hive replication command. By default, it has no limit. Pass 0 to explicitly set to unlimited.
String view = "summary"; // String | The view to materialize.
try {
    ApiReplicationScheduleList result = apiInstance.readSchedules(clusterName, serviceName, maxCommands, maxErrors, maxSchedules, maxTables, view);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReplicationsResourceApi#readSchedules");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clusterName** | **String**|  |
 **serviceName** | **String**| The service name. |
 **maxCommands** | **java.math.BigDecimal**| Maximum number of commands to include in the history of replication schedules. By default, it has no limit. Pass 0 to explicitly set to unlimited. | [optional] [default to 0]
 **maxErrors** | **java.math.BigDecimal**| Maximum number of errors per Hive replication command. By default, it has no limit. Pass 0 to explicitly set to unlimited. | [optional] [default to 0]
 **maxSchedules** | **java.math.BigDecimal**| Maximum number of replication schedules to be included in the response. By default, it has no limit. Pass 0 to explicitly set to unlimited. | [optional] [default to 0]
 **maxTables** | **java.math.BigDecimal**| Maximum number of tables per Hive replication command. By default, it has no limit. Pass 0 to explicitly set to unlimited. | [optional] [default to 0]
 **view** | **String**| The view to materialize. | [optional] [default to summary] [enum: EXPORT, EXPORT_REDACTED, FULL, FULL_WITH_HEALTH_CHECK_EXPLANATION, SUMMARY]

### Return type

[**ApiReplicationScheduleList**](ApiReplicationScheduleList.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="recreateCloudCredstoresOnHdfs"></a>
# **recreateCloudCredstoresOnHdfs**
> ApiCommand recreateCloudCredstoresOnHdfs(clusterName, serviceName)

Recreates the existing credential provider jceks files on HDFS, that are used by the given service, for replicating to the cloud.

Recreates the existing credential provider jceks files on HDFS, that are used by the given service, for replicating to the cloud.

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ReplicationsResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ReplicationsResourceApi apiInstance = new ReplicationsResourceApi();
String clusterName = "clusterName_example"; // String | 
String serviceName = "serviceName_example"; // String | The service name.
try {
    ApiCommand result = apiInstance.recreateCloudCredstoresOnHdfs(clusterName, serviceName);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReplicationsResourceApi#recreateCloudCredstoresOnHdfs");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clusterName** | **String**|  |
 **serviceName** | **String**| The service name. |

### Return type

[**ApiCommand**](ApiCommand.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="removeHBasePeer"></a>
# **removeHBasePeer**
> ApiCommand removeHBasePeer(clusterName, serviceName, body)

Starts a command that removes the specified HBase replication peer from the local HBase service.

Starts a command that removes the specified HBase replication peer from the local HBase service.

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ReplicationsResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ReplicationsResourceApi apiInstance = new ReplicationsResourceApi();
String clusterName = "clusterName_example"; // String | 
String serviceName = "serviceName_example"; // String | The service name.
ApiHBasePeerId body = new ApiHBasePeerId(); // ApiHBasePeerId | ID of the peer to be removed.
try {
    ApiCommand result = apiInstance.removeHBasePeer(clusterName, serviceName, body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReplicationsResourceApi#removeHBasePeer");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clusterName** | **String**|  |
 **serviceName** | **String**| The service name. |
 **body** | [**ApiHBasePeerId**](ApiHBasePeerId.md)| ID of the peer to be removed. | [optional]

### Return type

[**ApiCommand**](ApiCommand.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="removeTablesFromHBasePeer"></a>
# **removeTablesFromHBasePeer**
> ApiCommand removeTablesFromHBasePeer(clusterName, serviceName, body)

Starts a command that removes tables and column families from an existing HBase replication peer.

Starts a command that removes tables and column families from an existing HBase replication peer.

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ReplicationsResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ReplicationsResourceApi apiInstance = new ReplicationsResourceApi();
String clusterName = "clusterName_example"; // String | 
String serviceName = "serviceName_example"; // String | The service name.
ApiHBasePeerIdWithTableCFs body = new ApiHBasePeerIdWithTableCFs(); // ApiHBasePeerIdWithTableCFs | Arguments for removing tables from HBase replication peer.
try {
    ApiCommand result = apiInstance.removeTablesFromHBasePeer(clusterName, serviceName, body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReplicationsResourceApi#removeTablesFromHBasePeer");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clusterName** | **String**|  |
 **serviceName** | **String**| The service name. |
 **body** | [**ApiHBasePeerIdWithTableCFs**](ApiHBasePeerIdWithTableCFs.md)| Arguments for removing tables from HBase replication peer. | [optional]

### Return type

[**ApiCommand**](ApiCommand.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="rescheduleHive3ReplicationMetricsGetter"></a>
# **rescheduleHive3ReplicationMetricsGetter**
> Boolean rescheduleHive3ReplicationMetricsGetter(clusterName, serviceName, nextStartMins)

Set the Hive3 Replication Metrics Getter next start time.

Set the Hive3 Replication Metrics Getter next start time. <p> (Re)set the Hive3 Replication Metrics Getter next start time. Should be only used if the Getter needs to be manually started. <p>

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ReplicationsResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ReplicationsResourceApi apiInstance = new ReplicationsResourceApi();
String clusterName = "clusterName_example"; // String | 
String serviceName = "serviceName_example"; // String | The service name.
java.math.BigDecimal nextStartMins = new java.math.BigDecimal(); // java.math.BigDecimal | 
try {
    Boolean result = apiInstance.rescheduleHive3ReplicationMetricsGetter(clusterName, serviceName, nextStartMins);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReplicationsResourceApi#rescheduleHive3ReplicationMetricsGetter");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clusterName** | **String**|  |
 **serviceName** | **String**| The service name. |
 **nextStartMins** | **java.math.BigDecimal**|  | [optional] [default to 5]

### Return type

**Boolean**

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="runCopyListing"></a>
# **runCopyListing**
> ApiCommand runCopyListing(clusterName, serviceName, body)

Run the hdfs copy listing command.

Run the hdfs copy listing command <p> The copy listing command will be triggered with the provided arguments <p> Available since API v18. Only available with Cloudera Manager Enterprise Edition.

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ReplicationsResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ReplicationsResourceApi apiInstance = new ReplicationsResourceApi();
String clusterName = "clusterName_example"; // String | 
String serviceName = "serviceName_example"; // String | The service name.
String body = "body_example"; // String | 
try {
    ApiCommand result = apiInstance.runCopyListing(clusterName, serviceName, body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReplicationsResourceApi#runCopyListing");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clusterName** | **String**|  |
 **serviceName** | **String**| The service name. |
 **body** | **String**|  | [optional]

### Return type

[**ApiCommand**](ApiCommand.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="runHBaseReplicationRetryFailedSnapshots"></a>
# **runHBaseReplicationRetryFailedSnapshots**
> ApiCommand runHBaseReplicationRetryFailedSnapshots(clusterName, scheduleId, serviceName)

Executes a command to run a HBase replication retry on failed snapshots for the given schedule ID.

Executes a command to run a HBase replication retry on failed snapshots for the given schedule ID

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ReplicationsResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ReplicationsResourceApi apiInstance = new ReplicationsResourceApi();
String clusterName = "clusterName_example"; // String | 
java.math.BigDecimal scheduleId = new java.math.BigDecimal(); // java.math.BigDecimal | The HBase schedule ID to retry on
String serviceName = "serviceName_example"; // String | The service name.
try {
    ApiCommand result = apiInstance.runHBaseReplicationRetryFailedSnapshots(clusterName, scheduleId, serviceName);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReplicationsResourceApi#runHBaseReplicationRetryFailedSnapshots");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clusterName** | **String**|  |
 **scheduleId** | **java.math.BigDecimal**| The HBase schedule ID to retry on |
 **serviceName** | **String**| The service name. |

### Return type

[**ApiCommand**](ApiCommand.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="runHBaseReplicationSecurityTool"></a>
# **runHBaseReplicationSecurityTool**
> ApiCommand runHBaseReplicationSecurityTool(clusterName, serviceName, body)

Run the hbase replication security tool.

Run the hbase replication security tool <p> The replication security tool is invoked against the provided arguments <p>

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ReplicationsResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ReplicationsResourceApi apiInstance = new ReplicationsResourceApi();
String clusterName = "clusterName_example"; // String | 
String serviceName = "serviceName_example"; // String | The service name.
Object body = null; // Object | 
try {
    ApiCommand result = apiInstance.runHBaseReplicationSecurityTool(clusterName, serviceName, body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReplicationsResourceApi#runHBaseReplicationSecurityTool");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clusterName** | **String**|  |
 **serviceName** | **String**| The service name. |
 **body** | **Object**|  | [optional]

### Return type

[**ApiCommand**](ApiCommand.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="runHBaseReplicationValidationTool"></a>
# **runHBaseReplicationValidationTool**
> ApiCommand runHBaseReplicationValidationTool(clusterName, serviceName, hbasePeerId)

Executes a command, which validates if HBase replication works properly for the given hbasePeerId.

Executes a command, which validates if HBase replication works properly for the given hbasePeerId

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ReplicationsResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ReplicationsResourceApi apiInstance = new ReplicationsResourceApi();
String clusterName = "clusterName_example"; // String | 
String serviceName = "serviceName_example"; // String | The service name.
String hbasePeerId = "hbasePeerId_example"; // String | The HBase peer ID to be validated
try {
    ApiCommand result = apiInstance.runHBaseReplicationValidationTool(clusterName, serviceName, hbasePeerId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReplicationsResourceApi#runHBaseReplicationValidationTool");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clusterName** | **String**|  |
 **serviceName** | **String**| The service name. |
 **hbasePeerId** | **String**| The HBase peer ID to be validated | [optional]

### Return type

[**ApiCommand**](ApiCommand.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="runHiveReplicationQuery"></a>
# **runHiveReplicationQuery**
> ApiCommand runHiveReplicationQuery(clusterName, serviceName, body)

Execute a hive replication query on local HS2 service instance.

Execute a hive replication query on local HS2 service instance <p> The command executes hive replication query on local HS2 instance with the provided arguments <p>

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ReplicationsResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ReplicationsResourceApi apiInstance = new ReplicationsResourceApi();
String clusterName = "clusterName_example"; // String | 
String serviceName = "serviceName_example"; // String | The service name.
ApiHive3ReplicationArguments body = new ApiHive3ReplicationArguments(); // ApiHive3ReplicationArguments | 
try {
    ApiCommand result = apiInstance.runHiveReplicationQuery(clusterName, serviceName, body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReplicationsResourceApi#runHiveReplicationQuery");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clusterName** | **String**|  |
 **serviceName** | **String**| The service name. |
 **body** | [**ApiHive3ReplicationArguments**](ApiHive3ReplicationArguments.md)|  | [optional]

### Return type

[**ApiCommand**](ApiCommand.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="runSchedule"></a>
# **runSchedule**
> ApiCommand runSchedule(clusterName, scheduleId, serviceName, dryRun)

Run the schedule immediately.

Run the schedule immediately. <p> The replication command will be triggered with the configured arguments, and will be recorded in the schedule's history. <p> Available since API v3. Only available with Cloudera Manager Enterprise Edition.

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ReplicationsResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ReplicationsResourceApi apiInstance = new ReplicationsResourceApi();
String clusterName = "clusterName_example"; // String | 
java.math.BigDecimal scheduleId = new java.math.BigDecimal(); // java.math.BigDecimal | Id of an existing replication schedule.
String serviceName = "serviceName_example"; // String | The service name.
Boolean dryRun = false; // Boolean | Whether to execute a dry run.
try {
    ApiCommand result = apiInstance.runSchedule(clusterName, scheduleId, serviceName, dryRun);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReplicationsResourceApi#runSchedule");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clusterName** | **String**|  |
 **scheduleId** | **java.math.BigDecimal**| Id of an existing replication schedule. |
 **serviceName** | **String**| The service name. |
 **dryRun** | **Boolean**| Whether to execute a dry run. | [optional] [default to false]

### Return type

[**ApiCommand**](ApiCommand.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="setCFsReplicationScope"></a>
# **setCFsReplicationScope**
> ApiCommand setCFsReplicationScope(clusterName, serviceName, body)

Starts a command that set the replication scope of the provided column families to the desired value.

Starts a command that set the replication scope of the provided column families to the desired value.

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ReplicationsResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ReplicationsResourceApi apiInstance = new ReplicationsResourceApi();
String clusterName = "clusterName_example"; // String | 
String serviceName = "serviceName_example"; // String | The service name.
ApiHBaseSetCFsReplicationScope body = new ApiHBaseSetCFsReplicationScope(); // ApiHBaseSetCFsReplicationScope | Arguments for setting the replication scope.
try {
    ApiCommand result = apiInstance.setCFsReplicationScope(clusterName, serviceName, body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReplicationsResourceApi#setCFsReplicationScope");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clusterName** | **String**|  |
 **serviceName** | **String**| The service name. |
 **body** | [**ApiHBaseSetCFsReplicationScope**](ApiHBaseSetCFsReplicationScope.md)| Arguments for setting the replication scope. | [optional]

### Return type

[**ApiCommand**](ApiCommand.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="updateHBasePeerState"></a>
# **updateHBasePeerState**
> ApiCommand updateHBasePeerState(clusterName, serviceName, body)

Update HBase peer state ('DISABLE' or 'ENABLE'),.

Update HBase peer state ('DISABLE' or 'ENABLE'),<br/> and set the related HBase replication schedules <pre>ApiHBaseReplicationArguments.peerState</pre> for the given peer name (all schedules for the same source and target HBase service) according to the given state ('DISABLED' or 'ENABLED'). <pre>  example json data payload:  '{     \"sourceRef\": {       \"peerName\": \"source-peer-name\",       \"clusterName\": \"Cluster Name\",       \"serviceName\": \"HBase Service Name\"     }     \"peerState\": \"ENABLED|DISABLED\"   }'  </pre>

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ReplicationsResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ReplicationsResourceApi apiInstance = new ReplicationsResourceApi();
String clusterName = "clusterName_example"; // String | 
String serviceName = "serviceName_example"; // String | The service name.
ApiHBaseReplicationUpdatePeerStateArgs body = new ApiHBaseReplicationUpdatePeerStateArgs(); // ApiHBaseReplicationUpdatePeerStateArgs | ApiHBaseReplicationUpdatePeerStateArgs
try {
    ApiCommand result = apiInstance.updateHBasePeerState(clusterName, serviceName, body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReplicationsResourceApi#updateHBasePeerState");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clusterName** | **String**|  |
 **serviceName** | **String**| The service name. |
 **body** | [**ApiHBaseReplicationUpdatePeerStateArgs**](ApiHBaseReplicationUpdatePeerStateArgs.md)| ApiHBaseReplicationUpdatePeerStateArgs | [optional]

### Return type

[**ApiCommand**](ApiCommand.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="updateHBaseReplicationPeerState"></a>
# **updateHBaseReplicationPeerState**
> ApiCommand updateHBaseReplicationPeerState(clusterName, serviceName, body)

Starts a command that updates the state of an existing HBase replication peer.

Starts a command that updates the state of an existing HBase replication peer.

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ReplicationsResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ReplicationsResourceApi apiInstance = new ReplicationsResourceApi();
String clusterName = "clusterName_example"; // String | 
String serviceName = "serviceName_example"; // String | The service name.
ApiHBaseUpdateReplicationPeerState body = new ApiHBaseUpdateReplicationPeerState(); // ApiHBaseUpdateReplicationPeerState | Arguments for operation.
try {
    ApiCommand result = apiInstance.updateHBaseReplicationPeerState(clusterName, serviceName, body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReplicationsResourceApi#updateHBaseReplicationPeerState");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clusterName** | **String**|  |
 **serviceName** | **String**| The service name. |
 **body** | [**ApiHBaseUpdateReplicationPeerState**](ApiHBaseUpdateReplicationPeerState.md)| Arguments for operation. | [optional]

### Return type

[**ApiCommand**](ApiCommand.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="updateSchedule"></a>
# **updateSchedule**
> ApiReplicationSchedule updateSchedule(clusterName, scheduleId, serviceName, body)

Updates an existing replication schedule.

Updates an existing replication schedule. <p> Available since API v3. Only available with Cloudera Manager Enterprise Edition.

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.ReplicationsResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

ReplicationsResourceApi apiInstance = new ReplicationsResourceApi();
String clusterName = "clusterName_example"; // String | 
java.math.BigDecimal scheduleId = new java.math.BigDecimal(); // java.math.BigDecimal | Id of an existing replication schedule.
String serviceName = "serviceName_example"; // String | The service name.
ApiReplicationSchedule body = new ApiReplicationSchedule(); // ApiReplicationSchedule | 
try {
    ApiReplicationSchedule result = apiInstance.updateSchedule(clusterName, scheduleId, serviceName, body);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReplicationsResourceApi#updateSchedule");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clusterName** | **String**|  |
 **scheduleId** | **java.math.BigDecimal**| Id of an existing replication schedule. |
 **serviceName** | **String**| The service name. |
 **body** | [**ApiReplicationSchedule**](ApiReplicationSchedule.md)|  | [optional]

### Return type

[**ApiReplicationSchedule**](ApiReplicationSchedule.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

