# TagsResourceApi

All URIs are relative to *https://localhost/api/v51*

Method | HTTP request | Description
------------- | ------------- | -------------
[**getTags**](TagsResourceApi.md#getTags) | **GET** /tags | Current CM entities and their tags.
[**readTagsByName**](TagsResourceApi.md#readTagsByName) | **GET** /tags/{tagName} | Get Entities given the Tag name, grouped by entity type.


<a name="getTags"></a>
# **getTags**
> ApiTagToEntitiesList getTags(limit, offset)

Current CM entities and their tags.

Current CM entities and their tags. Tag names beginning with the prefix <code>_cldr_</code> (case insensitive) are reserved for internal use by Cloudera.

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.TagsResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

TagsResourceApi apiInstance = new TagsResourceApi();
java.math.BigDecimal limit = new java.math.BigDecimal(); // java.math.BigDecimal | Number of tags to search for. Maximum value for limit is 1000.
java.math.BigDecimal offset = new java.math.BigDecimal(); // java.math.BigDecimal | Starting index of the list
try {
    ApiTagToEntitiesList result = apiInstance.getTags(limit, offset);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling TagsResourceApi#getTags");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **limit** | **java.math.BigDecimal**| Number of tags to search for. Maximum value for limit is 1000. | [optional] [default to 10]
 **offset** | **java.math.BigDecimal**| Starting index of the list | [optional] [default to 0]

### Return type

[**ApiTagToEntitiesList**](ApiTagToEntitiesList.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="readTagsByName"></a>
# **readTagsByName**
> ApiTagToEntitiesList readTagsByName(tagName, limit, offset)

Get Entities given the Tag name, grouped by entity type.

Get Entities given the Tag name, grouped by entity type.

### Example
```java
// Import classes:
//import com.cloudera.api.swagger.client.ApiClient;
//import com.cloudera.api.swagger.client.ApiException;
//import com.cloudera.api.swagger.client.Configuration;
//import com.cloudera.api.swagger.client.auth.*;
//import com.cloudera.api.swagger.TagsResourceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure HTTP basic authorization: basic
HttpBasicAuth basic = (HttpBasicAuth) defaultClient.getAuthentication("basic");
basic.setUsername("YOUR USERNAME");
basic.setPassword("YOUR PASSWORD");

TagsResourceApi apiInstance = new TagsResourceApi();
String tagName = "tagName_example"; // String | Name of the tag
java.math.BigDecimal limit = new java.math.BigDecimal(); // java.math.BigDecimal | Number of entries to search for. Maximum value for limit is 1000.
java.math.BigDecimal offset = new java.math.BigDecimal(); // java.math.BigDecimal | Starting index of the list
try {
    ApiTagToEntitiesList result = apiInstance.readTagsByName(tagName, limit, offset);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling TagsResourceApi#readTagsByName");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tagName** | **String**| Name of the tag |
 **limit** | **java.math.BigDecimal**| Number of entries to search for. Maximum value for limit is 1000. | [optional] [default to 10]
 **offset** | **java.math.BigDecimal**| Starting index of the list | [optional] [default to 0]

### Return type

[**ApiTagToEntitiesList**](ApiTagToEntitiesList.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

