/*
 * Cloudera Manager API
 * <h1>Cloudera Manager API v51</h1>       <p>Introduced in Cloudera Manager 7.9.5</p>       <p><a href=\"http://www.cloudera.com/documentation.html\">Cloudera Product Documentation</a></p>
 *
 * OpenAPI spec version: 7.9.5
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.cloudera.api.swagger.model;

import java.util.Objects;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;

/**
 * Information about a cluster support token. &lt;p&gt; The cluster support token indicates the current usage of a cluster managed by Cloudera Manager. The cluster support token is an ASCII encoded string of 32 characters. It is unique to each cluster.
 */
@ApiModel(description = "Information about a cluster support token. <p> The cluster support token indicates the current usage of a cluster managed by Cloudera Manager. The cluster support token is an ASCII encoded string of 32 characters. It is unique to each cluster.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2023-01-19T07:17:06.859Z")
public class ApiClusterSupportToken {
  @SerializedName("clusterName")
  private String clusterName = null;

  @SerializedName("displayName")
  private String displayName = null;

  @SerializedName("clusterSupportToken")
  private String clusterSupportToken = null;

  public ApiClusterSupportToken clusterName(String clusterName) {
    this.clusterName = clusterName;
    return this;
  }

   /**
   * The name of the cluster. &lt;p&gt; Immutable since API v6. &lt;p&gt; Prior to API v6, will contain the display name of the cluster.
   * @return clusterName
  **/
  @ApiModelProperty(value = "The name of the cluster. <p> Immutable since API v6. <p> Prior to API v6, will contain the display name of the cluster.")
  public String getClusterName() {
    return clusterName;
  }

  public void setClusterName(String clusterName) {
    this.clusterName = clusterName;
  }

  public ApiClusterSupportToken displayName(String displayName) {
    this.displayName = displayName;
    return this;
  }

   /**
   * The display name of the cluster that is shown in the UI. &lt;p&gt; Available since API v6.
   * @return displayName
  **/
  @ApiModelProperty(value = "The display name of the cluster that is shown in the UI. <p> Available since API v6.")
  public String getDisplayName() {
    return displayName;
  }

  public void setDisplayName(String displayName) {
    this.displayName = displayName;
  }

  public ApiClusterSupportToken clusterSupportToken(String clusterSupportToken) {
    this.clusterSupportToken = clusterSupportToken;
    return this;
  }

   /**
   * The unique support token for a cluster. &lt;p&gt; Available since API v43.
   * @return clusterSupportToken
  **/
  @ApiModelProperty(value = "The unique support token for a cluster. <p> Available since API v43.")
  public String getClusterSupportToken() {
    return clusterSupportToken;
  }

  public void setClusterSupportToken(String clusterSupportToken) {
    this.clusterSupportToken = clusterSupportToken;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ApiClusterSupportToken apiClusterSupportToken = (ApiClusterSupportToken) o;
    return Objects.equals(this.clusterName, apiClusterSupportToken.clusterName) &&
        Objects.equals(this.displayName, apiClusterSupportToken.displayName) &&
        Objects.equals(this.clusterSupportToken, apiClusterSupportToken.clusterSupportToken);
  }

  @Override
  public int hashCode() {
    return Objects.hash(clusterName, displayName, clusterSupportToken);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ApiClusterSupportToken {\n");
    
    sb.append("    clusterName: ").append(toIndentedString(clusterName)).append("\n");
    sb.append("    displayName: ").append(toIndentedString(displayName)).append("\n");
    sb.append("    clusterSupportToken: ").append(toIndentedString(clusterSupportToken)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

