/*
 * Cloudera Manager API
 * <h1>Cloudera Manager API v51</h1>       <p>Introduced in Cloudera Manager 7.9.5</p>       <p><a href=\"http://www.cloudera.com/documentation.html\">Cloudera Product Documentation</a></p>
 *
 * OpenAPI spec version: 7.9.5
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.cloudera.api.swagger.model;

import java.util.Objects;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Arguments for TRANSFORMING Ranger services and policies, executed after EXPORT (see ApiRangerReplicationExportArgs).
 */
@ApiModel(description = "Arguments for TRANSFORMING Ranger services and policies, executed after EXPORT (see ApiRangerReplicationExportArgs).")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2023-01-19T07:17:06.859Z")
public class ApiRangerReplicationTransformArgs {
  @SerializedName("rangerServiceNamesMapping")
  private Map<String, String> rangerServiceNamesMapping = null;

  @SerializedName("rangerUsersMapping")
  private Map<String, String> rangerUsersMapping = null;

  @SerializedName("rangerResourcesMapping")
  private Map<String, String> rangerResourcesMapping = null;

  public ApiRangerReplicationTransformArgs rangerServiceNamesMapping(Map<String, String> rangerServiceNamesMapping) {
    this.rangerServiceNamesMapping = rangerServiceNamesMapping;
    return this;
  }

  public ApiRangerReplicationTransformArgs putRangerServiceNamesMappingItem(String key, String rangerServiceNamesMappingItem) {
    if (this.rangerServiceNamesMapping == null) {
      this.rangerServiceNamesMapping = new HashMap<String, String>();
    }
    this.rangerServiceNamesMapping.put(key, rangerServiceNamesMappingItem);
    return this;
  }

   /**
   * A mapping between source to destination ranger services. &lt;p&gt; Note that if a mapping is not given for a service then it will stay the same on the destination. &lt;p&gt; Example: {\&quot;cm_hdfs\&quot;:\&quot;dr_hdfs\&quot;, \&quot;cm_hive\&quot;:\&quot;dr_hive\&quot;} &lt;br&gt; Default: empty or null, every service name will stay the same on the destination
   * @return rangerServiceNamesMapping
  **/
  @ApiModelProperty(value = "A mapping between source to destination ranger services. <p> Note that if a mapping is not given for a service then it will stay the same on the destination. <p> Example: {\"cm_hdfs\":\"dr_hdfs\", \"cm_hive\":\"dr_hive\"} <br> Default: empty or null, every service name will stay the same on the destination")
  public Map<String, String> getRangerServiceNamesMapping() {
    return rangerServiceNamesMapping;
  }

  public void setRangerServiceNamesMapping(Map<String, String> rangerServiceNamesMapping) {
    this.rangerServiceNamesMapping = rangerServiceNamesMapping;
  }

  public ApiRangerReplicationTransformArgs rangerUsersMapping(Map<String, String> rangerUsersMapping) {
    this.rangerUsersMapping = rangerUsersMapping;
    return this;
  }

  public ApiRangerReplicationTransformArgs putRangerUsersMappingItem(String key, String rangerUsersMappingItem) {
    if (this.rangerUsersMapping == null) {
      this.rangerUsersMapping = new HashMap<String, String>();
    }
    this.rangerUsersMapping.put(key, rangerUsersMappingItem);
    return this;
  }

   /**
   * A mapping between source to destination ranger usernames. &lt;p&gt; Note that if a mapping is not given for a username then it will stay the same on the destination. &lt;p&gt; Example: {\&quot;testuser1\&quot;:\&quot;testuser1@host.com\&quot;, \&quot;testuser2\&quot;:\&quot;testuser2@host.com\&quot; }&lt;br&gt; Default: empty or null, every username will stay the same on the destination
   * @return rangerUsersMapping
  **/
  @ApiModelProperty(value = "A mapping between source to destination ranger usernames. <p> Note that if a mapping is not given for a username then it will stay the same on the destination. <p> Example: {\"testuser1\":\"testuser1@host.com\", \"testuser2\":\"testuser2@host.com\" }<br> Default: empty or null, every username will stay the same on the destination")
  public Map<String, String> getRangerUsersMapping() {
    return rangerUsersMapping;
  }

  public void setRangerUsersMapping(Map<String, String> rangerUsersMapping) {
    this.rangerUsersMapping = rangerUsersMapping;
  }

  public ApiRangerReplicationTransformArgs rangerResourcesMapping(Map<String, String> rangerResourcesMapping) {
    this.rangerResourcesMapping = rangerResourcesMapping;
    return this;
  }

  public ApiRangerReplicationTransformArgs putRangerResourcesMappingItem(String key, String rangerResourcesMappingItem) {
    if (this.rangerResourcesMapping == null) {
      this.rangerResourcesMapping = new HashMap<String, String>();
    }
    this.rangerResourcesMapping.put(key, rangerResourcesMappingItem);
    return this;
  }

   /**
   * A mapping between source to destination ranger resources. &lt;p&gt; Note that if a mapping is not given for a resource then it will stay the same on the destination. &lt;p&gt; Example: {\&quot;/srcdir1/srcfile1\&quot;:\&quot;/destdir1/destfile1\&quot;, \&quot;/srcdir2/srcfile2\&quot;:\&quot;/destdir2/destfile2\&quot; }&lt;br&gt; Default: empty or null, every resource will have the same path on the destination
   * @return rangerResourcesMapping
  **/
  @ApiModelProperty(value = "A mapping between source to destination ranger resources. <p> Note that if a mapping is not given for a resource then it will stay the same on the destination. <p> Example: {\"/srcdir1/srcfile1\":\"/destdir1/destfile1\", \"/srcdir2/srcfile2\":\"/destdir2/destfile2\" }<br> Default: empty or null, every resource will have the same path on the destination")
  public Map<String, String> getRangerResourcesMapping() {
    return rangerResourcesMapping;
  }

  public void setRangerResourcesMapping(Map<String, String> rangerResourcesMapping) {
    this.rangerResourcesMapping = rangerResourcesMapping;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ApiRangerReplicationTransformArgs apiRangerReplicationTransformArgs = (ApiRangerReplicationTransformArgs) o;
    return Objects.equals(this.rangerServiceNamesMapping, apiRangerReplicationTransformArgs.rangerServiceNamesMapping) &&
        Objects.equals(this.rangerUsersMapping, apiRangerReplicationTransformArgs.rangerUsersMapping) &&
        Objects.equals(this.rangerResourcesMapping, apiRangerReplicationTransformArgs.rangerResourcesMapping);
  }

  @Override
  public int hashCode() {
    return Objects.hash(rangerServiceNamesMapping, rangerUsersMapping, rangerResourcesMapping);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ApiRangerReplicationTransformArgs {\n");
    
    sb.append("    rangerServiceNamesMapping: ").append(toIndentedString(rangerServiceNamesMapping)).append("\n");
    sb.append("    rangerUsersMapping: ").append(toIndentedString(rangerUsersMapping)).append("\n");
    sb.append("    rangerResourcesMapping: ").append(toIndentedString(rangerResourcesMapping)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

