/*
 * Cloudera Manager API
 * <h1>Cloudera Manager API v51</h1>       <p>Introduced in Cloudera Manager 7.9.5</p>       <p><a href=\"http://www.cloudera.com/documentation.html\">Cloudera Product Documentation</a></p>
 *
 * OpenAPI spec version: 7.9.5
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.cloudera.api.swagger.model;

import java.util.Objects;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;

/**
 * Arguments used to upgrade a Private Cloud Control Plane on embedded kubernetes and the associated Containerized Cluster.
 */
@ApiModel(description = "Arguments used to upgrade a Private Cloud Control Plane on embedded kubernetes and the associated Containerized Cluster.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2023-01-19T07:17:06.859Z")
public class ApiUpgradeEmbeddedControlPlaneArgs {
  @SerializedName("remoteRepoUrl")
  private String remoteRepoUrl = null;

  @SerializedName("valuesYaml")
  private String valuesYaml = null;

  @SerializedName("experienceClusterName")
  private String experienceClusterName = null;

  @SerializedName("containerizedClusterName")
  private String containerizedClusterName = null;

  public ApiUpgradeEmbeddedControlPlaneArgs remoteRepoUrl(String remoteRepoUrl) {
    this.remoteRepoUrl = remoteRepoUrl;
    return this;
  }

   /**
   * The url of the remote repository where the private cloud artifacts to upgrade to are hosted
   * @return remoteRepoUrl
  **/
  @ApiModelProperty(value = "The url of the remote repository where the private cloud artifacts to upgrade to are hosted")
  public String getRemoteRepoUrl() {
    return remoteRepoUrl;
  }

  public void setRemoteRepoUrl(String remoteRepoUrl) {
    this.remoteRepoUrl = remoteRepoUrl;
  }

  public ApiUpgradeEmbeddedControlPlaneArgs valuesYaml(String valuesYaml) {
    this.valuesYaml = valuesYaml;
    return this;
  }

   /**
   * A yaml file containing configuration parameters for the upgrade.
   * @return valuesYaml
  **/
  @ApiModelProperty(value = "A yaml file containing configuration parameters for the upgrade.")
  public String getValuesYaml() {
    return valuesYaml;
  }

  public void setValuesYaml(String valuesYaml) {
    this.valuesYaml = valuesYaml;
  }

  public ApiUpgradeEmbeddedControlPlaneArgs experienceClusterName(String experienceClusterName) {
    this.experienceClusterName = experienceClusterName;
    return this;
  }

   /**
   * Deprecated. Use containerizedClusterName instead.
   * @return experienceClusterName
  **/
  @ApiModelProperty(value = "Deprecated. Use containerizedClusterName instead.")
  public String getExperienceClusterName() {
    return experienceClusterName;
  }

  public void setExperienceClusterName(String experienceClusterName) {
    this.experienceClusterName = experienceClusterName;
  }

  public ApiUpgradeEmbeddedControlPlaneArgs containerizedClusterName(String containerizedClusterName) {
    this.containerizedClusterName = containerizedClusterName;
    return this;
  }

   /**
   * The name of the existing Containerized Cluster to upgrade.
   * @return containerizedClusterName
  **/
  @ApiModelProperty(value = "The name of the existing Containerized Cluster to upgrade.")
  public String getContainerizedClusterName() {
    return containerizedClusterName;
  }

  public void setContainerizedClusterName(String containerizedClusterName) {
    this.containerizedClusterName = containerizedClusterName;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ApiUpgradeEmbeddedControlPlaneArgs apiUpgradeEmbeddedControlPlaneArgs = (ApiUpgradeEmbeddedControlPlaneArgs) o;
    return Objects.equals(this.remoteRepoUrl, apiUpgradeEmbeddedControlPlaneArgs.remoteRepoUrl) &&
        Objects.equals(this.valuesYaml, apiUpgradeEmbeddedControlPlaneArgs.valuesYaml) &&
        Objects.equals(this.experienceClusterName, apiUpgradeEmbeddedControlPlaneArgs.experienceClusterName) &&
        Objects.equals(this.containerizedClusterName, apiUpgradeEmbeddedControlPlaneArgs.containerizedClusterName);
  }

  @Override
  public int hashCode() {
    return Objects.hash(remoteRepoUrl, valuesYaml, experienceClusterName, containerizedClusterName);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ApiUpgradeEmbeddedControlPlaneArgs {\n");
    
    sb.append("    remoteRepoUrl: ").append(toIndentedString(remoteRepoUrl)).append("\n");
    sb.append("    valuesYaml: ").append(toIndentedString(valuesYaml)).append("\n");
    sb.append("    experienceClusterName: ").append(toIndentedString(experienceClusterName)).append("\n");
    sb.append("    containerizedClusterName: ").append(toIndentedString(containerizedClusterName)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

