/*
 * Cloudera Manager API
 * <h1>Cloudera Manager API v51</h1>       <p>Introduced in Cloudera Manager 7.9.5</p>       <p><a href=\"http://www.cloudera.com/documentation.html\">Cloudera Product Documentation</a></p>
 *
 * OpenAPI spec version: 7.9.5
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.cloudera.api.swagger;

import com.cloudera.api.swagger.client.ApiException;
import com.cloudera.api.swagger.model.ApiCommand;
import com.cloudera.api.swagger.model.ApiHBaseAddReplicationPeerInput;
import com.cloudera.api.swagger.model.ApiHBaseCreateTable;
import com.cloudera.api.swagger.model.ApiHBasePeerId;
import com.cloudera.api.swagger.model.ApiHBasePeerIdWithTableCFs;
import com.cloudera.api.swagger.model.ApiHBaseReplicationUpdatePeerStateArgs;
import com.cloudera.api.swagger.model.ApiHBaseSetCFsReplicationScope;
import com.cloudera.api.swagger.model.ApiHBaseTableNames;
import com.cloudera.api.swagger.model.ApiHBaseUpdateReplicationPeerState;
import com.cloudera.api.swagger.model.ApiHive3ReplicationArguments;
import com.cloudera.api.swagger.model.ApiRangerReplicationExportArgs;
import com.cloudera.api.swagger.model.ApiReplicationCommandList;
import com.cloudera.api.swagger.model.ApiReplicationDiagnosticsCollectionArgs;
import com.cloudera.api.swagger.model.ApiReplicationSchedule;
import com.cloudera.api.swagger.model.ApiReplicationScheduleList;
import com.cloudera.api.swagger.model.ApiReplicationState;
import org.junit.Test;
import org.junit.Ignore;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for ReplicationsResourceApi
 */
@Ignore
public class ReplicationsResourceApiTest {

    private final ReplicationsResourceApi api = new ReplicationsResourceApi();

    
    /**
     * Starts a command that adds a new replication peer to HBase.
     *
     * Starts a command that adds a new replication peer to HBase.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void addHBaseReplicationPeerTest() throws ApiException {
        String clusterName = null;
        String serviceName = null;
        ApiHBaseAddReplicationPeerInput body = null;
        ApiCommand response = api.addHBaseReplicationPeer(clusterName, serviceName, body);

        // TODO: test validations
    }
    
    /**
     * Starts a command that adds tables and column families to an existing HBase replication peer.
     *
     * Starts a command that adds tables and column families to an existing HBase replication peer.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void addTablesToHBasePeerTest() throws ApiException {
        String clusterName = null;
        String serviceName = null;
        ApiHBasePeerIdWithTableCFs body = null;
        ApiCommand response = api.addTablesToHBasePeer(clusterName, serviceName, body);

        // TODO: test validations
    }
    
    /**
     * Starts a command that checks if the specified tables exist in HBase.
     *
     * Starts a command that checks if the specified tables exist in HBase.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void checkHBaseTablesExistTest() throws ApiException {
        String clusterName = null;
        String serviceName = null;
        ApiHBaseTableNames body = null;
        ApiCommand response = api.checkHBaseTablesExist(clusterName, serviceName, body);

        // TODO: test validations
    }
    
    /**
     * Collect diagnostic data for a schedule, optionally for a subset of commands on that schedule, matched by schedule ID.
     *
     * Collect diagnostic data for a schedule, optionally for a subset of commands on that schedule, matched by schedule ID.  The returned command&#39;s resultDataUrl property, upon the commands completion, will refer to the generated diagnostic data. Available since API v11.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void collectDiagnosticDataTest() throws ApiException {
        String clusterName = null;
        java.math.BigDecimal scheduleId = null;
        String serviceName = null;
        String view = null;
        ApiReplicationDiagnosticsCollectionArgs body = null;
        ApiCommand response = api.collectDiagnosticData(clusterName, scheduleId, serviceName, view, body);

        // TODO: test validations
    }
    
    /**
     * Creates a credstore provider jceks file on HDFS for the given service.
     *
     * Creates a credstore provider jceks file on HDFS for the given service. The file will store credential information for the given sourceAccount.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void createCloudCredstoreOnHdfsTest() throws ApiException {
        String clusterName = null;
        String serviceName = null;
        Boolean force = null;
        String sourceAccount = null;
        ApiCommand response = api.createCloudCredstoreOnHdfs(clusterName, serviceName, force, sourceAccount);

        // TODO: test validations
    }
    
    /**
     * Use the following API endpoint instead:.
     *
     * Use the following API endpoint instead: &lt;b/&gt; com.cloudera.api.v50.ReplicationsResourceV50#createCloudCredstoreOnHdfs(String, boolean)
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void createCredstoreTest() throws ApiException {
        String clusterName = null;
        String serviceName = null;
        String credstoreDirPath = null;
        Boolean force = null;
        String sourceAccount = null;
        ApiCommand response = api.createCredstore(clusterName, serviceName, credstoreDirPath, force, sourceAccount);

        // TODO: test validations
    }
    
    /**
     * Starts a command that creates a new table in HBase.
     *
     * Starts a command that creates a new table in HBase.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void createHBaseTableTest() throws ApiException {
        String clusterName = null;
        String serviceName = null;
        ApiHBaseCreateTable body = null;
        ApiCommand response = api.createHBaseTable(clusterName, serviceName, body);

        // TODO: test validations
    }
    
    /**
     * Creates one or more replication schedules.
     *
     * Creates one or more replication schedules. &lt;p&gt; Available since API v3. Only available with Cloudera Manager Enterprise Edition.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void createSchedulesTest() throws ApiException {
        String clusterName = null;
        String serviceName = null;
        ApiReplicationScheduleList body = null;
        ApiReplicationScheduleList response = api.createSchedules(clusterName, serviceName, body);

        // TODO: test validations
    }
    
    /**
     * Deletes all existing replication schedules.
     *
     * Deletes all existing replication schedules. &lt;p&gt; Available since API v3. Only available with Cloudera Manager Enterprise Edition.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void deleteAllSchedulesTest() throws ApiException {
        String clusterName = null;
        String serviceName = null;
        ApiReplicationScheduleList response = api.deleteAllSchedules(clusterName, serviceName);

        // TODO: test validations
    }
    
    /**
     * Deletes an existing replication schedule.
     *
     * Deletes an existing replication schedule. &lt;p&gt; Available since API v3. Only available with Cloudera Manager Enterprise Edition.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void deleteScheduleTest() throws ApiException {
        String clusterName = null;
        java.math.BigDecimal scheduleId = null;
        String serviceName = null;
        ApiReplicationSchedule response = api.deleteSchedule(clusterName, scheduleId, serviceName);

        // TODO: test validations
    }
    
    /**
     * Exports the given Ranger services and policies (defined in the API body) to a zipped file.
     *
     * Exports the given Ranger services and policies (defined in the API body) to a zipped file.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void exportRangerServicesTest() throws ApiException {
        String clusterName = null;
        String serviceName = null;
        ApiRangerReplicationExportArgs body = null;
        ApiCommand response = api.exportRangerServices(clusterName, serviceName, body);

        // TODO: test validations
    }
    
    /**
     * Starts a command that fetches column families for the desired tables.
     *
     * Starts a command that fetches column families for the desired tables.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void fetchHBaseColumnFamiliesTest() throws ApiException {
        String clusterName = null;
        String serviceName = null;
        ApiHBaseTableNames body = null;
        ApiCommand response = api.fetchHBaseColumnFamilies(clusterName, serviceName, body);

        // TODO: test validations
    }
    
    /**
     * Starts a command that fetches information about an HBase peer by its ID.
     *
     * Starts a command that fetches information about an HBase peer by its ID.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void fetchHBasePeerInfoTest() throws ApiException {
        String clusterName = null;
        String serviceName = null;
        ApiHBasePeerId body = null;
        ApiCommand response = api.fetchHBasePeerInfo(clusterName, serviceName, body);

        // TODO: test validations
    }
    
    /**
     * Deletes an existing replication schedule only from the DB.
     *
     * Deletes an existing replication schedule only from the DB. &lt;p&gt; Only the DB schedule reference is deleted with no further cleanup on the source or target side. Typically this endpoint can be used when the source cluster is not available any more and normal policy delete fails during cleanup.  Available since API v46. Only available with Cloudera Manager Enterprise Edition.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void forceDeleteScheduleTest() throws ApiException {
        String clusterName = null;
        java.math.BigDecimal scheduleId = null;
        String serviceName = null;
        ApiReplicationSchedule response = api.forceDeleteSchedule(clusterName, scheduleId, serviceName);

        // TODO: test validations
    }
    
    /**
     * (Re)generates the cloud credential provider password, used by the given service, for replicating to the cloud.
     *
     * (Re)generates the cloud credential provider password, used by the given service, for replicating to the cloud. &lt;br/&gt; Calling this API endpoint may cause staleness for the given service. &lt;br/&gt; NOTE: If this API endpoint REGENERATED the credstore password successfully and there are existing credstore provider jceks files on HDFS, protected by this password, then these jceks files should be recreated by using the following API endpoint: #recreateCloudCredstoresOnHdfs().
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void generateCloudReplCredstorePasswordTest() throws ApiException {
        String clusterName = null;
        String serviceName = null;
        String passwordGenerateMode = null;
        Boolean response = api.generateCloudReplCredstorePassword(clusterName, serviceName, passwordGenerateMode);

        // TODO: test validations
    }
    
    /**
     * returns the replication state.
     *
     * returns the replication state. for example if incremental export is enabled, etc
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getReplicationStateTest() throws ApiException {
        String clusterName = null;
        String serviceName = null;
        String view = null;
        ApiReplicationState response = api.getReplicationState(clusterName, serviceName, view);

        // TODO: test validations
    }
    
    /**
     * This API endpoint checks if there is an ENABLED Hive3 replication policy on this server that replicates for the reverse direction.
     *
     * This API endpoint checks if there is an ENABLED Hive3 replication policy on this server that replicates for the reverse direction. Bidirectional Hive3 replication policies are allowed, but only one direction can be ENABLED at the same time.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void isHive3ReverseDirectionEnabledTest() throws ApiException {
        String clusterName = null;
        String serviceName = null;
        String clusterUuidOnRemote = null;
        String serviceNameOnRemote = null;
        String sourceDbNameOnRemote = null;
        String targetDbNameOnRemote = null;
        Boolean response = api.isHive3ReverseDirectionEnabled(clusterName, serviceName, clusterUuidOnRemote, serviceNameOnRemote, sourceDbNameOnRemote, targetDbNameOnRemote);

        // TODO: test validations
    }
    
    /**
     * Starts a command that lists all namespaces in HBase.
     *
     * Starts a command that lists all namespaces in HBase.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void listHBaseNamespacesTest() throws ApiException {
        String clusterName = null;
        String serviceName = null;
        ApiCommand response = api.listHBaseNamespaces(clusterName, serviceName);

        // TODO: test validations
    }
    
    /**
     * Starts a command that retrieves all peers registered in the HBase service.
     *
     * Starts a command that retrieves all peers registered in the HBase service.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void listHBasePeersTest() throws ApiException {
        String clusterName = null;
        String serviceName = null;
        ApiCommand response = api.listHBasePeers(clusterName, serviceName);

        // TODO: test validations
    }
    
    /**
     * Starts a command that lists tables from the HBase service.
     *
     * Starts a command that lists tables from the HBase service.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void listHBaseTablesTest() throws ApiException {
        String clusterName = null;
        String serviceName = null;
        ApiCommand response = api.listHBaseTables(clusterName, serviceName);

        // TODO: test validations
    }
    
    /**
     * Returns a list of commands triggered by a schedule.
     *
     * Returns a list of commands triggered by a schedule.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void readHistoryTest() throws ApiException {
        String clusterName = null;
        java.math.BigDecimal scheduleId = null;
        String serviceName = null;
        java.math.BigDecimal limit = null;
        java.math.BigDecimal offset = null;
        String view = null;
        ApiReplicationCommandList response = api.readHistory(clusterName, scheduleId, serviceName, limit, offset, view);

        // TODO: test validations
    }
    
    /**
     * Returns information for a specific replication schedule.
     *
     * Returns information for a specific replication schedule. &lt;p&gt; Available since API v3. Only available with Cloudera Manager Enterprise Edition.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void readScheduleTest() throws ApiException {
        String clusterName = null;
        java.math.BigDecimal scheduleId = null;
        String serviceName = null;
        String view = null;
        ApiReplicationSchedule response = api.readSchedule(clusterName, scheduleId, serviceName, view);

        // TODO: test validations
    }
    
    /**
     * Retrieves information about replication schedules.
     *
     * Retrieves information about replication schedules.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void readSchedulesTest() throws ApiException {
        String clusterName = null;
        String serviceName = null;
        java.math.BigDecimal maxCommands = null;
        java.math.BigDecimal maxErrors = null;
        java.math.BigDecimal maxSchedules = null;
        java.math.BigDecimal maxTables = null;
        String view = null;
        ApiReplicationScheduleList response = api.readSchedules(clusterName, serviceName, maxCommands, maxErrors, maxSchedules, maxTables, view);

        // TODO: test validations
    }
    
    /**
     * Recreates the existing credential provider jceks files on HDFS, that are used by the given service, for replicating to the cloud.
     *
     * Recreates the existing credential provider jceks files on HDFS, that are used by the given service, for replicating to the cloud.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void recreateCloudCredstoresOnHdfsTest() throws ApiException {
        String clusterName = null;
        String serviceName = null;
        ApiCommand response = api.recreateCloudCredstoresOnHdfs(clusterName, serviceName);

        // TODO: test validations
    }
    
    /**
     * Starts a command that removes the specified HBase replication peer from the local HBase service.
     *
     * Starts a command that removes the specified HBase replication peer from the local HBase service.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void removeHBasePeerTest() throws ApiException {
        String clusterName = null;
        String serviceName = null;
        ApiHBasePeerId body = null;
        ApiCommand response = api.removeHBasePeer(clusterName, serviceName, body);

        // TODO: test validations
    }
    
    /**
     * Starts a command that removes tables and column families from an existing HBase replication peer.
     *
     * Starts a command that removes tables and column families from an existing HBase replication peer.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void removeTablesFromHBasePeerTest() throws ApiException {
        String clusterName = null;
        String serviceName = null;
        ApiHBasePeerIdWithTableCFs body = null;
        ApiCommand response = api.removeTablesFromHBasePeer(clusterName, serviceName, body);

        // TODO: test validations
    }
    
    /**
     * Set the Hive3 Replication Metrics Getter next start time.
     *
     * Set the Hive3 Replication Metrics Getter next start time. &lt;p&gt; (Re)set the Hive3 Replication Metrics Getter next start time. Should be only used if the Getter needs to be manually started. &lt;p&gt;
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void rescheduleHive3ReplicationMetricsGetterTest() throws ApiException {
        String clusterName = null;
        String serviceName = null;
        java.math.BigDecimal nextStartMins = null;
        Boolean response = api.rescheduleHive3ReplicationMetricsGetter(clusterName, serviceName, nextStartMins);

        // TODO: test validations
    }
    
    /**
     * Run the hdfs copy listing command.
     *
     * Run the hdfs copy listing command &lt;p&gt; The copy listing command will be triggered with the provided arguments &lt;p&gt; Available since API v18. Only available with Cloudera Manager Enterprise Edition.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void runCopyListingTest() throws ApiException {
        String clusterName = null;
        String serviceName = null;
        String body = null;
        ApiCommand response = api.runCopyListing(clusterName, serviceName, body);

        // TODO: test validations
    }
    
    /**
     * Executes a command to run a HBase replication retry on failed snapshots for the given schedule ID.
     *
     * Executes a command to run a HBase replication retry on failed snapshots for the given schedule ID
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void runHBaseReplicationRetryFailedSnapshotsTest() throws ApiException {
        String clusterName = null;
        java.math.BigDecimal scheduleId = null;
        String serviceName = null;
        ApiCommand response = api.runHBaseReplicationRetryFailedSnapshots(clusterName, scheduleId, serviceName);

        // TODO: test validations
    }
    
    /**
     * Run the hbase replication security tool.
     *
     * Run the hbase replication security tool &lt;p&gt; The replication security tool is invoked against the provided arguments &lt;p&gt;
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void runHBaseReplicationSecurityToolTest() throws ApiException {
        String clusterName = null;
        String serviceName = null;
        Object body = null;
        ApiCommand response = api.runHBaseReplicationSecurityTool(clusterName, serviceName, body);

        // TODO: test validations
    }
    
    /**
     * Executes a command, which validates if HBase replication works properly for the given hbasePeerId.
     *
     * Executes a command, which validates if HBase replication works properly for the given hbasePeerId
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void runHBaseReplicationValidationToolTest() throws ApiException {
        String clusterName = null;
        String serviceName = null;
        String hbasePeerId = null;
        ApiCommand response = api.runHBaseReplicationValidationTool(clusterName, serviceName, hbasePeerId);

        // TODO: test validations
    }
    
    /**
     * Execute a hive replication query on local HS2 service instance.
     *
     * Execute a hive replication query on local HS2 service instance &lt;p&gt; The command executes hive replication query on local HS2 instance with the provided arguments &lt;p&gt;
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void runHiveReplicationQueryTest() throws ApiException {
        String clusterName = null;
        String serviceName = null;
        ApiHive3ReplicationArguments body = null;
        ApiCommand response = api.runHiveReplicationQuery(clusterName, serviceName, body);

        // TODO: test validations
    }
    
    /**
     * Run the schedule immediately.
     *
     * Run the schedule immediately. &lt;p&gt; The replication command will be triggered with the configured arguments, and will be recorded in the schedule&#39;s history. &lt;p&gt; Available since API v3. Only available with Cloudera Manager Enterprise Edition.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void runScheduleTest() throws ApiException {
        String clusterName = null;
        java.math.BigDecimal scheduleId = null;
        String serviceName = null;
        Boolean dryRun = null;
        ApiCommand response = api.runSchedule(clusterName, scheduleId, serviceName, dryRun);

        // TODO: test validations
    }
    
    /**
     * Starts a command that set the replication scope of the provided column families to the desired value.
     *
     * Starts a command that set the replication scope of the provided column families to the desired value.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void setCFsReplicationScopeTest() throws ApiException {
        String clusterName = null;
        String serviceName = null;
        ApiHBaseSetCFsReplicationScope body = null;
        ApiCommand response = api.setCFsReplicationScope(clusterName, serviceName, body);

        // TODO: test validations
    }
    
    /**
     * Update HBase peer state (&#39;DISABLE&#39; or &#39;ENABLE&#39;),.
     *
     * Update HBase peer state (&#39;DISABLE&#39; or &#39;ENABLE&#39;),&lt;br/&gt; and set the related HBase replication schedules &lt;pre&gt;ApiHBaseReplicationArguments.peerState&lt;/pre&gt; for the given peer name (all schedules for the same source and target HBase service) according to the given state (&#39;DISABLED&#39; or &#39;ENABLED&#39;). &lt;pre&gt;  example json data payload:  &#39;{     \&quot;sourceRef\&quot;: {       \&quot;peerName\&quot;: \&quot;source-peer-name\&quot;,       \&quot;clusterName\&quot;: \&quot;Cluster Name\&quot;,       \&quot;serviceName\&quot;: \&quot;HBase Service Name\&quot;     }     \&quot;peerState\&quot;: \&quot;ENABLED|DISABLED\&quot;   }&#39;  &lt;/pre&gt;
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void updateHBasePeerStateTest() throws ApiException {
        String clusterName = null;
        String serviceName = null;
        ApiHBaseReplicationUpdatePeerStateArgs body = null;
        ApiCommand response = api.updateHBasePeerState(clusterName, serviceName, body);

        // TODO: test validations
    }
    
    /**
     * Starts a command that updates the state of an existing HBase replication peer.
     *
     * Starts a command that updates the state of an existing HBase replication peer.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void updateHBaseReplicationPeerStateTest() throws ApiException {
        String clusterName = null;
        String serviceName = null;
        ApiHBaseUpdateReplicationPeerState body = null;
        ApiCommand response = api.updateHBaseReplicationPeerState(clusterName, serviceName, body);

        // TODO: test validations
    }
    
    /**
     * Updates an existing replication schedule.
     *
     * Updates an existing replication schedule. &lt;p&gt; Available since API v3. Only available with Cloudera Manager Enterprise Edition.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void updateScheduleTest() throws ApiException {
        String clusterName = null;
        java.math.BigDecimal scheduleId = null;
        String serviceName = null;
        ApiReplicationSchedule body = null;
        ApiReplicationSchedule response = api.updateSchedule(clusterName, scheduleId, serviceName, body);

        // TODO: test validations
    }
    
}
