# coding: utf-8

"""
    Cloudera Manager API

    <h1>Cloudera Manager API v51</h1>       <p>Introduced in Cloudera Manager 7.9.5</p>       <p><a href=\"http://www.cloudera.com/documentation.html\">Cloudera Product Documentation</a></p>

    OpenAPI spec version: 7.9.5
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class ApiAddSBNNToNSArguments(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name_service_name': 'str',
        'new_nn_host_ids': 'list[str]',
        'new_nn_data_dirs': 'dict(str, str)',
        'clear_data_dirs': 'bool',
        'restart_cluster': 'bool'
    }

    attribute_map = {
        'name_service_name': 'nameServiceName',
        'new_nn_host_ids': 'newNNHostIds',
        'new_nn_data_dirs': 'newNNDataDirs',
        'clear_data_dirs': 'clearDataDirs',
        'restart_cluster': 'restartCluster'
    }

    def __init__(self, name_service_name=None, new_nn_host_ids=None, new_nn_data_dirs=None, clear_data_dirs=None, restart_cluster=None):
        """
        ApiAddSBNNToNSArguments - a model defined in Swagger
        """

        self._name_service_name = None
        self._new_nn_host_ids = None
        self._new_nn_data_dirs = None
        self._clear_data_dirs = None
        self._restart_cluster = None

        if name_service_name is not None:
          self.name_service_name = name_service_name
        if new_nn_host_ids is not None:
          self.new_nn_host_ids = new_nn_host_ids
        if new_nn_data_dirs is not None:
          self.new_nn_data_dirs = new_nn_data_dirs
        if clear_data_dirs is not None:
          self.clear_data_dirs = clear_data_dirs
        if restart_cluster is not None:
          self.restart_cluster = restart_cluster

    @property
    def name_service_name(self):
        """
        Gets the name_service_name of this ApiAddSBNNToNSArguments.
        The name of the NameService to which the new NameNode(s) should be added.

        :return: The name_service_name of this ApiAddSBNNToNSArguments.
        :rtype: str
        """
        return self._name_service_name

    @name_service_name.setter
    def name_service_name(self, name_service_name):
        """
        Sets the name_service_name of this ApiAddSBNNToNSArguments.
        The name of the NameService to which the new NameNode(s) should be added.

        :param name_service_name: The name_service_name of this ApiAddSBNNToNSArguments.
        :type: str
        """

        self._name_service_name = name_service_name

    @property
    def new_nn_host_ids(self):
        """
        Gets the new_nn_host_ids of this ApiAddSBNNToNSArguments.
        List of host ids to which new NameNode(s) should be added.

        :return: The new_nn_host_ids of this ApiAddSBNNToNSArguments.
        :rtype: list[str]
        """
        return self._new_nn_host_ids

    @new_nn_host_ids.setter
    def new_nn_host_ids(self, new_nn_host_ids):
        """
        Sets the new_nn_host_ids of this ApiAddSBNNToNSArguments.
        List of host ids to which new NameNode(s) should be added.

        :param new_nn_host_ids: The new_nn_host_ids of this ApiAddSBNNToNSArguments.
        :type: list[str]
        """

        self._new_nn_host_ids = new_nn_host_ids

    @property
    def new_nn_data_dirs(self):
        """
        Gets the new_nn_data_dirs of this ApiAddSBNNToNSArguments.
        Mapping of NameNode Data Directories list to host id(s), key is the host id, the value is a comma separated list of directories to be set as NameNode Data Directories for the new NameNode(s).

        :return: The new_nn_data_dirs of this ApiAddSBNNToNSArguments.
        :rtype: dict(str, str)
        """
        return self._new_nn_data_dirs

    @new_nn_data_dirs.setter
    def new_nn_data_dirs(self, new_nn_data_dirs):
        """
        Sets the new_nn_data_dirs of this ApiAddSBNNToNSArguments.
        Mapping of NameNode Data Directories list to host id(s), key is the host id, the value is a comma separated list of directories to be set as NameNode Data Directories for the new NameNode(s).

        :param new_nn_data_dirs: The new_nn_data_dirs of this ApiAddSBNNToNSArguments.
        :type: dict(str, str)
        """

        self._new_nn_data_dirs = new_nn_data_dirs

    @property
    def clear_data_dirs(self):
        """
        Gets the clear_data_dirs of this ApiAddSBNNToNSArguments.
        Specifies whether the NameNode Data Directories configured should be cleared as a first step, or the command should fail if the directories specified are not empty.

        :return: The clear_data_dirs of this ApiAddSBNNToNSArguments.
        :rtype: bool
        """
        return self._clear_data_dirs

    @clear_data_dirs.setter
    def clear_data_dirs(self, clear_data_dirs):
        """
        Sets the clear_data_dirs of this ApiAddSBNNToNSArguments.
        Specifies whether the NameNode Data Directories configured should be cleared as a first step, or the command should fail if the directories specified are not empty.

        :param clear_data_dirs: The clear_data_dirs of this ApiAddSBNNToNSArguments.
        :type: bool
        """

        self._clear_data_dirs = clear_data_dirs

    @property
    def restart_cluster(self):
        """
        Gets the restart_cluster of this ApiAddSBNNToNSArguments.
        Specifies whether the HDFS dependent services of the cluster should be restarted after the changes are applied, to reconfigure dependent services

        :return: The restart_cluster of this ApiAddSBNNToNSArguments.
        :rtype: bool
        """
        return self._restart_cluster

    @restart_cluster.setter
    def restart_cluster(self, restart_cluster):
        """
        Sets the restart_cluster of this ApiAddSBNNToNSArguments.
        Specifies whether the HDFS dependent services of the cluster should be restarted after the changes are applied, to reconfigure dependent services

        :param restart_cluster: The restart_cluster of this ApiAddSBNNToNSArguments.
        :type: bool
        """

        self._restart_cluster = restart_cluster

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, ApiAddSBNNToNSArguments):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
