# coding: utf-8

"""
    Cloudera Manager API

    <h1>Cloudera Manager API v51</h1>       <p>Introduced in Cloudera Manager 7.9.5</p>       <p><a href=\"http://www.cloudera.com/documentation.html\">Cloudera Product Documentation</a></p>

    OpenAPI spec version: 7.9.5
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class ApiRangerReplicationTransformArgs(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'ranger_service_names_mapping': 'dict(str, str)',
        'ranger_users_mapping': 'dict(str, str)',
        'ranger_resources_mapping': 'dict(str, str)'
    }

    attribute_map = {
        'ranger_service_names_mapping': 'rangerServiceNamesMapping',
        'ranger_users_mapping': 'rangerUsersMapping',
        'ranger_resources_mapping': 'rangerResourcesMapping'
    }

    def __init__(self, ranger_service_names_mapping=None, ranger_users_mapping=None, ranger_resources_mapping=None):
        """
        ApiRangerReplicationTransformArgs - a model defined in Swagger
        """

        self._ranger_service_names_mapping = None
        self._ranger_users_mapping = None
        self._ranger_resources_mapping = None

        if ranger_service_names_mapping is not None:
          self.ranger_service_names_mapping = ranger_service_names_mapping
        if ranger_users_mapping is not None:
          self.ranger_users_mapping = ranger_users_mapping
        if ranger_resources_mapping is not None:
          self.ranger_resources_mapping = ranger_resources_mapping

    @property
    def ranger_service_names_mapping(self):
        """
        Gets the ranger_service_names_mapping of this ApiRangerReplicationTransformArgs.
        A mapping between source to destination ranger services. <p> Note that if a mapping is not given for a service then it will stay the same on the destination. <p> Example: {\"cm_hdfs\":\"dr_hdfs\", \"cm_hive\":\"dr_hive\"} <br> Default: empty or null, every service name will stay the same on the destination

        :return: The ranger_service_names_mapping of this ApiRangerReplicationTransformArgs.
        :rtype: dict(str, str)
        """
        return self._ranger_service_names_mapping

    @ranger_service_names_mapping.setter
    def ranger_service_names_mapping(self, ranger_service_names_mapping):
        """
        Sets the ranger_service_names_mapping of this ApiRangerReplicationTransformArgs.
        A mapping between source to destination ranger services. <p> Note that if a mapping is not given for a service then it will stay the same on the destination. <p> Example: {\"cm_hdfs\":\"dr_hdfs\", \"cm_hive\":\"dr_hive\"} <br> Default: empty or null, every service name will stay the same on the destination

        :param ranger_service_names_mapping: The ranger_service_names_mapping of this ApiRangerReplicationTransformArgs.
        :type: dict(str, str)
        """

        self._ranger_service_names_mapping = ranger_service_names_mapping

    @property
    def ranger_users_mapping(self):
        """
        Gets the ranger_users_mapping of this ApiRangerReplicationTransformArgs.
        A mapping between source to destination ranger usernames. <p> Note that if a mapping is not given for a username then it will stay the same on the destination. <p> Example: {\"testuser1\":\"testuser1@host.com\", \"testuser2\":\"testuser2@host.com\" }<br> Default: empty or null, every username will stay the same on the destination

        :return: The ranger_users_mapping of this ApiRangerReplicationTransformArgs.
        :rtype: dict(str, str)
        """
        return self._ranger_users_mapping

    @ranger_users_mapping.setter
    def ranger_users_mapping(self, ranger_users_mapping):
        """
        Sets the ranger_users_mapping of this ApiRangerReplicationTransformArgs.
        A mapping between source to destination ranger usernames. <p> Note that if a mapping is not given for a username then it will stay the same on the destination. <p> Example: {\"testuser1\":\"testuser1@host.com\", \"testuser2\":\"testuser2@host.com\" }<br> Default: empty or null, every username will stay the same on the destination

        :param ranger_users_mapping: The ranger_users_mapping of this ApiRangerReplicationTransformArgs.
        :type: dict(str, str)
        """

        self._ranger_users_mapping = ranger_users_mapping

    @property
    def ranger_resources_mapping(self):
        """
        Gets the ranger_resources_mapping of this ApiRangerReplicationTransformArgs.
        A mapping between source to destination ranger resources. <p> Note that if a mapping is not given for a resource then it will stay the same on the destination. <p> Example: {\"/srcdir1/srcfile1\":\"/destdir1/destfile1\", \"/srcdir2/srcfile2\":\"/destdir2/destfile2\" }<br> Default: empty or null, every resource will have the same path on the destination

        :return: The ranger_resources_mapping of this ApiRangerReplicationTransformArgs.
        :rtype: dict(str, str)
        """
        return self._ranger_resources_mapping

    @ranger_resources_mapping.setter
    def ranger_resources_mapping(self, ranger_resources_mapping):
        """
        Sets the ranger_resources_mapping of this ApiRangerReplicationTransformArgs.
        A mapping between source to destination ranger resources. <p> Note that if a mapping is not given for a resource then it will stay the same on the destination. <p> Example: {\"/srcdir1/srcfile1\":\"/destdir1/destfile1\", \"/srcdir2/srcfile2\":\"/destdir2/destfile2\" }<br> Default: empty or null, every resource will have the same path on the destination

        :param ranger_resources_mapping: The ranger_resources_mapping of this ApiRangerReplicationTransformArgs.
        :type: dict(str, str)
        """

        self._ranger_resources_mapping = ranger_resources_mapping

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, ApiRangerReplicationTransformArgs):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
