# cm_client.CspResourceApi

All URIs are relative to *https://localhost/api/v51*

Method | HTTP request | Description
------------- | ------------- | -------------
[**upload_csp_cert**](CspResourceApi.md#upload_csp_cert) | **PUT** /csp/uploadCspCert | Upload CA certificates, client certificates and client key for Credential Storage Provider.


<a name="upload_csp_cert" id="upload_csp_cert"></a>
# **upload_csp_cert**
> ApiCspArguments upload_csp_cert(body=body)

Upload CA certificates, client certificates and client key for Credential Storage Provider.

Upload CA certificates, client certificates and client key for Credential Storage Provider. CM server restart is needed for these certificates to be applied.

### Example
```python
from __future__ import print_function
import time
import cm_client
from cm_client.rest import ApiException
from pprint import pprint

# Configure HTTP basic authorization: basic
configuration = cm_client.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = cm_client.CspResourceApi(cm_client.ApiClient(configuration))
body = cm_client.ApiCspArguments() # ApiCspArguments | Arguments for the CSP (optional)

try:
    # Upload CA certificates, client certificates and client key for Credential Storage Provider.
    api_response = api_instance.upload_csp_cert(body=body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling CspResourceApi->upload_csp_cert: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**ApiCspArguments**](ApiCspArguments.md)| Arguments for the CSP | [optional] 

### Return type

[**ApiCspArguments**](ApiCspArguments.md)

### Authorization

[basic](../README.md#basic)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

